AG = {}

AG.name = 'AlphaGear'
AG.displayname = 'AlphaGear 2'
AG.version = 'v6.4.1 beta1'
AG.author = 'AlphaLemming & mesota'
AG.init = false
AG.pendingSet = -1
AG.previousSet = nil
AG.accountVariableVersion = 2
AG.characterVariableVersion = 1

AG.CHOICE_SHOW_ITEM_LEVEL_ALWAYS = 1
AG.CHOICE_SHOW_ITEM_LEVEL_LOW = 2
AG.CHOICE_SHOW_ITEM_LEVEL_NEVER = 3

AG.OUTFIT_NONE = 0
AG.OUTFIT_KEEP = -1

AG.MODE_GEAR = 'Gear'
AG.MODE_SKILL = 'Skill'

AG.account = {}
AG.account_defaults = {
	option = {true, true, true, true, true, true, true, true, true, true, true, false, true, true, AG.CHOICE_SHOW_ITEM_LEVEL_NEVER},
    
	-- default positions of UIElements
	positions = {
		["AG_UI_ButtonBg"] = {GuiRoot:GetWidth()/2, 200},
		["AG_SetButtonBg"] = {GuiRoot:GetWidth()-365, 450},
		["AG_SwapMessageBg"] = {GuiRoot:GetWidth()-365, 530},
		["AG_Panel"] = {GuiRoot:GetWidth()/2 - 335, GuiRoot:GetHeight()/2 - 410}
	}
}


AG.setdata = {}
AG.setdata_defaults = {
   setamount = 16,
   lastset = false,
}


-- Update Event Queue
AG.Jobs = {}                -- List of jobs to be executed in the OnUpdate event. Element of form {JOB_TYPE, BAG, SLOT}
AG.NextEventTime = 0        -- Time for the next event
AG.JOB_TYPE_UNEQUIP_GEAR = 1   
AG.JOB_TYPE_DEPOSIT_GEAR = 2   
AG.JOB_TYPE_WITHDRAW_GEAR = 3
AG.JOB_TYPE_UPDATE_UI = 4
AG.JOB_TYPE_LOAD_SKILL_BAR = 5
AG.JOB_TYPE_SHOW_SWAP_MSG = 6
AG.JOB_TYPE_EQUIP_GEAR = 7

-- local IDLE, GEARQUEUE = 0, {}


local UIElements = {}

local L, ZOSF = AGLang.msg, zo_strformat
local MAXSLOT, MENU, SELECT, SELECTBAR, DRAGINFO, TTANI, SWAP = 16, { nr = nil, type = nil, copy = nil }, false, false, {}, false, false
local EM, WM, SM, ICON, MARK, AVAIL_EQUIPMENT_CACHE = EVENT_MANAGER, WINDOW_MANAGER, SCENE_MANAGER, {}, {}, nil
local OFMGR = ZO_OUTFIT_MANAGER
local IMGR = PLAYER_INVENTORY
local MAX_PROFILES = 20 

local SLOTS, DUPSLOTS = {
    {EQUIP_SLOT_MAIN_HAND,'mainhand','MainHand'},
    {EQUIP_SLOT_OFF_HAND,'offhand','OffHand'},
    {EQUIP_SLOT_BACKUP_MAIN,'mainhand','BackupMain'},
    {EQUIP_SLOT_BACKUP_OFF,'offhand','BackupOff'},
    {EQUIP_SLOT_HEAD,'head','Head'},
    {EQUIP_SLOT_CHEST,'chest','Chest'},
    {EQUIP_SLOT_LEGS,'legs','Leg'},
    {EQUIP_SLOT_SHOULDERS,'shoulders','Shoulder'},
    {EQUIP_SLOT_FEET,'feet','Foot'},
    {EQUIP_SLOT_WAIST,'belt','Belt'},
    {EQUIP_SLOT_HAND,'hands','Glove'},
    {EQUIP_SLOT_NECK,'neck','Neck'},
    {EQUIP_SLOT_RING1,'ring','Ring1'},
    {EQUIP_SLOT_RING2,'ring','Ring2'},
    {EQUIP_SLOT_POISON,'poison','Poison'},
    {EQUIP_SLOT_BACKUP_POISON,'poison','BackupPoison'},
},
{1,2,3,4,13,14}



--- Writes trace messages to the console
-- fmt with %d, %s,
local function trace(fmt, ...)
-- TODO: Make configurable
	if false then
		d(string.format(fmt, ...))
    end
end


--- Computes a color depending on the condition of an item.
-- @param val condition value
-- @param a alpha value
-- @return rgb and alpha
local function GetColor(val, a)
    local r,g = 0,0
    
    if val > 100 then val = 100 end
    
    if val >= 50 then 
        r = 100-((val-50)*2)
        g = 100 
    else 
        r = 100
        g = val*2 
    end
    
    return r/100, g/100, 0, a
end

--- Computes a color depending on the quality of the item.
-- @param link link to item
-- @param a alpha value
-- @return rgb and alpha
local function Quality(link,a)
    local QUALITY = {[0]={0.65,0.65,0.65,a},[1]={1,1,1,a},[2]={0.17,0.77,0.05,a},[3]={0.22,0.57,1,a},[4]={0.62,0.18,0.96,a},[5]={0.80,0.66,0.10,a}}
    return unpack(QUALITY[GetItemLinkQuality(link)])
end

local function Zero(val) if val == 0 then return nil else return val end end

--- Hides a control
-- Used for charge and repair icons
-- @param c control to hide
local function Hide(c)
	c:SetHidden(true); 
	c:SetWidth(0) 
end

--- Shows a control
-- Used for charge and repair icons
-- @param c control to show
local function Show(c)
	c:SetHidden(false); 
	c:SetWidth(50) 
end

--- Shows or hides a control
-- Used for charge and repair icons
-- @param c control to show
-- @param visible show or hide
function AG.layoutControl(c, visible)
	c:SetHidden (not visible)
	if visible then
		c:SetWidth (50)
	else 
		c:SetWidth (0)
	end
end




-- AG.DrawMenu reveals or hides the menu when invoked
function AG.DrawMenu(c,line)
    AG_PanelMenu:ToggleHidden()
    AG_PanelMenu:SetAnchor(3,c,6,0,0)
    local h, c = 0
    for z,x in pairs(line) do
        c = AG_PanelMenu:GetChild(z)
        if x then
            h = h + 30
            c:SetHeight(30)
            c:SetHidden(false)
        else
            c:SetHeight(0)
            c:SetHidden(true)
        end
    end
    AG_PanelMenu:SetHeight(h + 20)

end

--- Creates item quality indicator controls to be shown in the inventory
function AG.DrawInventory()
    trace ('DrawInventory started')

    for _,c in pairs(SLOTS) do
        local p = WM:GetControlByName('ZO_CharacterEquipmentSlots'..c[3])
		
		-- Quality Control
        local s = WM:CreateControl('AG_InvBg'..c[1], p, CT_TEXTURE)
        s:SetHidden(true)
        s:SetDrawLevel(1)
        s:SetTexture('AlphaGear/hole.dds')
        s:SetAnchorFill()
		
		-- Condition Control
        s = WM:CreateControl('AG_InvBg'..c[1]..'Condition', p, CT_LABEL)
        s:SetFont('ZoFontGameSmall')
        s:SetAnchor(TOPRIGHT,p,TOPRIGHT,7,-8)
        s:SetDimensions(50,10)
        s:SetHidden(true)
        s:SetHorizontalAlignment(TEXT_ALIGN_RIGHT)
		
		-- Level Control
        s = WM:CreateControl('AG_InvBg'..c[1]..'Level', p, CT_TEXTURE)
        -- s:SetFont('ZoFontGameLarge')
        s:SetAnchor(TOPLEFT,p,TOPLEFT,0,-3)
        s:SetDimensions(10,10)
        s:SetHidden(true)
		s:SetDrawLayer(p:GetDrawLayer() + 1)
	    -- s:SetAnchorFill()
		-- s:SetDrawLevel(1)

        -- s:SetHorizontalAlignment(TEXT_ALIGN_LEFT)
    end
end


--- creates buttons for gear and skill
-- @param p Parent
-- @param name One of "Button" == button in gear- or skill-set, "edit" == button in edit-panel
-- @param btn One of 'Gear', 'Skill'
-- @param nr number of the set in "button"-mode, One of "1", "2" in "edit"-mode, "1" is mainhand, "2" is offhand
-- @param x number of slot in set
function AG.DrawButton(p, name, btn, nr, x, xpos, ypos, show)

    -- creates buttons with names like
    -- AG_Edit_Gear_1
    local c = WM:CreateControl('AG_'..name..'_'..btn..'_'..nr..'_'..x, p, CT_BUTTON)
    if show then c:SetAnchor(3,p,3,xpos,ypos) else c:SetAnchor(2,p,2,xpos,ypos) end
    c:SetDrawTier(1)
    c:SetDimensions(40,40)
    c:SetMouseOverTexture('AlphaGear/light.dds')
    c:SetHandler('OnMouseEnter',function(self) AG.Tooltip(self,true,show) end)
    c:SetHandler('OnMouseExit',function(self) AG.Tooltip(self,false,show) end)

    local b = WM:CreateControl('AG_'..name..'_'..btn..'_'..nr..'_'..x..'Bg', c, CT_BACKDROP)
    b:SetAnchor(128,c,128,0,0)
    b:SetDimensions(44,44)
    b:SetCenterColor(0,0,0,0.2)

    if name == 'Button' and btn == AG.MODE_GEAR then
        b:SetEdgeColor(AG.GetItemBorderColor(nr, x))
    else
        -- no border
        b:SetEdgeColor(0, 0, 0, 0)
    end 

    b:SetEdgeTexture('',1,1,2)
    b:SetInsets(2,2,-2,-2)
    
    if not show then
        c:SetClickSound('Click')
        c:EnableMouseButton(2,true)
        c:SetHandler('OnReceiveDrag',function(self) AG.OnDragReceive(self) end)

        if btn == AG.MODE_GEAR then 
            c:SetHandler('OnMouseDown',
                function(self,button,ctrl,alt,shift)
                    if button == 2 then 
                        AG.setdata[nr].Gear[x] = { id = 0, link = 0 }
                        AG.ShowButton(self)
                    elseif shift then 
                        if button == 1 then
                            if GetItemInstanceId(BAG_WORN, SLOTS[x][1]) then
                                AG.setdata[nr].Gear[x] = { id = Id64ToString(GetItemUniqueId(BAG_WORN, SLOTS[x][1])), link = GetItemLink(BAG_WORN, SLOTS[x][1]) }
                            else 
                                AG.setdata[nr].Gear[x] = { id = 0, link = 0 } 
                            end
                            AG.ShowButton(self)
                        end
                    elseif button == 1 then 
                        AG.LoadItem(nr, x) 
                    end
                end
            ) 
        end

        if btn == AG.MODE_SKILL then 
            c:SetHandler('OnMouseDown',
                function(self,button,ctrl,alt,shift)
                    if button == 2 then 
                        AG.setdata[nr].Skill[x] = 0
                        AG.ShowButton(self)
                    elseif shift then
                        if button == 1 then
                            local abilityId = GetSlotBoundId(x+2)
                            local baseAbilityId = 0
                    
                            if abilityId ~= 0 then
                                baseAbilityId = AG.GetBaseAbilityId(abilityId)
                            end
                    
                            AG.setdata[nr].Skill[x] = baseAbilityId
                            AG.ShowButton(self) 
                        end
                    elseif button == 1 then 
                        AG.LoadSkill(nr,x) 
                    end 
                end
            ) 
        end
        AG.ShowButton(c)
    end
end


function AG.CreateButtonBarPanel(nr, modestr, parent, width)
    local name = 'AG_Selector_'..modestr..'_'..nr
    
    local p = WM:CreateControl(name, parent, CT_BUTTON) 
    p:SetAnchor(3, nil, 3, 0, 45*(nr-1))
    p:SetDimensions(width, 44)
    p:SetClickSound('Click')
    p:EnableMouseButton(2, true)
    p:SetNormalTexture('AlphaGear/grey.dds')
    p:SetMouseOverTexture('AlphaGear/light.dds')
    p.data = { header = '|cFFAA33'..L.Head[modestr]..nr..'|r', info = L.Selector[modestr] }
    p:SetHandler('OnMouseEnter',function(self) AG.Tooltip(self,true) end)
    p:SetHandler('OnMouseExit',function(self) AG.Tooltip(self,false) end)

    return p
end

function AG.CreateButtonBarLabel(nr, modestr, parent)
    local name = 'AG_Selector_'..modestr..'_'..nr..'_Label'

    local c = WM:CreateControl(name, parent, CT_LABEL)
    c:SetAnchor(3, parent, 3, 0, 0)
    c:SetDrawTier(1)
    c:SetDimensions(44,44)
    c:SetHorizontalAlignment(1)
    c:SetVerticalAlignment(1)
    c:SetFont('AGFontBold')
    c:SetColor(1,1,1,0.8)
    c:SetText(nr)
end


function AG.DrawSkillBarButtons(nr)
    local p = AG.CreateButtonBarPanel(nr, AG.MODE_SKILL, AG_PanelSkillPanelScrollChild, 299)

    p:SetHandler('OnMouseDown',
        function(self,button,ctrl,alt,shift)
            if button == 2 then
                AG.DrawMenu(self, {true, (MENU.copy and MENU.type == 2), true, true, false, false})
                MENU.nr = nr
                MENU.type = 2 -- 2 == Skill
            elseif shift then 
                if button == 1 then 
                    AG.GetSkillFromBar(nr)
                    AG.UpdateEditPanel(nr) 
                end
            elseif button == 1 then 
                if SELECTBAR then 
                    AG.setdata[SELECT].Set.skill[SELECTBAR] = nr
                    SELECTBAR = false
                    AG.SetConnect(1,2)
                    AG.UpdateEditPanel(SELECT) 
                else 
                    AG.LoadBar(nr) 
                end 
            end
        end
    ) 

    AG.CreateButtonBarLabel(nr, AG.MODE_SKILL, p)

    -- Draw buttons for skills
    for x = 1, 6 do AG.DrawButton(p,'Button', AG.MODE_SKILL, nr, x, 46+42*(x-1), 0) end
end

function AG.DrawGearBarButtons(nr)
    local p = AG.CreateButtonBarPanel(nr, AG.MODE_GEAR, AG_PanelGearPanelScrollChild, 751)

    p:SetHandler('OnMouseDown',
        function(self,button,ctrl,alt,shift)
            if button == 2 then 
                local isBanking = IMGR:IsBanking()

                AG.DrawMenu(self, {true, (MENU.copy and MENU.type == 1), true, true, isBanking, isBanking})
                MENU.nr = nr
                MENU.type = 1 -- 1 == Gear
            elseif shift then 
                if button == 1 then 
                    MENU.type = 1 -- 1 == Gear
                    MENU.nr = nr
                    AG.MenuAction(3)
                    AG.UpdateEditPanel(SELECT) 
                end
            elseif button == 1 then 
                if SELECTBAR then 
                    AG.setdata[SELECT].Set.gear = nr
                    SELECTBAR = false
                    AG.SetConnect(3,2)
                    AG.UpdateEditPanel(SELECT) 
                else 
                    AG.LoadGear(nr) 
                end 
            end
        end
    ) 

    AG.CreateButtonBarLabel(nr, AG.MODE_GEAR, p)

    -- Draw buttons for gear
    -- positions do not match order in SLOTS-Array
    local positions = {1,2,4,5,7,8,9,10,11,12,13,14,15,16,3,6}
    for x = 1, #SLOTS do 
        AG.DrawButton(p,'Button', AG.MODE_GEAR, nr, x, 46+44*(positions[x]-1), 0) 
    end
end




function AG.SetupMainPanel()

    -- Create Key Binding Labels
    ZO_CreateStringId('SI_BINDING_NAME_SHOW_AG_WINDOW', L.ShowMainBinding)
    ZO_CreateStringId('SI_BINDING_NAME_AG_UNDRESS', L.UneqipAllBinding)
    ZO_CreateStringId('SI_BINDING_NAME_AG_NEXT_SET', L.BindLoadNextSet)
    ZO_CreateStringId('SI_BINDING_NAME_AG_PREVIOUS_SET', L.BindLoadPreviousSet)
    ZO_CreateStringId('SI_BINDING_NAME_AG_TOGGLE_SET', L.BindToggleSet)
    
    -- create MAXSLOT skill-sets, gear-sets and sets
    for x = 1, MAXSLOT do
        -- Create Key Binding Label
        ZO_CreateStringId('SI_BINDING_NAME_AG_SET_'..x, L.LoadSetBinding..x)
        -- builds
        AG.DrawBuild(x)

        -- gear-sets
        AG.DrawGearBarButtons(x)

        -- skill-sets
        AG.DrawSkillBarButtons(x)
    end

    -- create skill buttons (Main and Backup) in edit panel
    for x = 1,6 do
        AG.DrawButton(AG_PanelSetPanelScrollChildEditPanelSetBar1PanelSkill11Box,'Edit', AG.MODE_SKILL, 1,x,42*(x-1),0,true)
        AG.DrawButton(AG_PanelSetPanelScrollChildEditPanelSetBar2PanelSkill21Box,'Edit', AG.MODE_SKILL, 2,x,42*(x-1),0,true)
    end

    -- create weapon buttons (Main and Backup) in skill edit panel
    for x = 1,2 do
        AG.DrawButton(AG_PanelSetPanelScrollChildEditPanelSetBar1PanelWeap1Box,'Edit', AG.MODE_GEAR, 1, x, 42*(x-1), 0, true)
        AG.DrawButton(AG_PanelSetPanelScrollChildEditPanelSetBar2PanelWeap2Box,'Edit', AG.MODE_GEAR, 1, x+2, 42*(x-1), 0, true)
    end

    -- create poison buttons (Main and Backup) in skill edit panel
    AG.DrawButton(AG_PanelSetPanelScrollChildEditPanelSetBar1PanelWeap1Box,'Edit', AG.MODE_GEAR, 1, 15, 84, 0, true)
    AG.DrawButton(AG_PanelSetPanelScrollChildEditPanelSetBar2PanelWeap2Box,'Edit', AG.MODE_GEAR, 1, 16, 84, 0, true)

    -- create gear buttons, row 1 in edit panel
    for x = 5,11 do AG.DrawButton(AG_PanelSetPanelScrollChildEditPanelSetGearPanelGear1Box,'Edit', AG.MODE_GEAR, 1,x,42*(x-5),0,true) end

    -- create gear buttons, row 2 in edit panel
    for x = 12,14 do AG.DrawButton(AG_PanelSetPanelScrollChildEditPanelSetGearPanelGear2Box,'Edit', AG.MODE_GEAR, 1,x,42*(x-12),0,true) end


    -- ZO_PreHook('ZO_Skills_AbilitySlot_OnDragStart', AG.OnSkillDragStart)
    
    -- ZO_PreHook('ZO_InventorySlot_OnDragStart', AG.OnItemDragStart)

    ZO_PreHookHandler(AG_PanelMenu,'OnShow', 
        function()
            zo_callLater(
                function() 
                    EM:RegisterForEvent('AG4',EVENT_GLOBAL_MOUSE_UP,
                        function()
                            AG_PanelMenu:SetHidden(true)
                            EM:UnregisterForEvent('AG4',EVENT_GLOBAL_MOUSE_UP)
                        end
                    ) 
                end
            , 250)
        end
    )

    ZO_PreHookHandler(ZO_Skills,'OnShow', function() AG.AlignMainPanel(ZO_Skills, -25) end)
    ZO_PreHookHandler(ZO_Skills,'OnHide', AG.UnalignMainPanel)
    ZO_PreHookHandler(ZO_PlayerInventory,'OnShow', function() AG.AlignMainPanel(ZO_PlayerInventory,0) end)
    ZO_PreHookHandler(ZO_PlayerInventory,'OnHide', AG.UnalignMainPanel)
    ZO_PreHookHandler(ZO_ChampionPerks,'OnShow', function() SM:HideTopLevel(AG_Panel) end)
    ZO_PreHookHandler(AG_Panel,'OnHide', 
	    function() 
		    AG_PanelIcons:SetHidden(true)
        end
    )

    AG_PanelIcons.useFadeGradient = false
    AG_PanelSetPanel.useFadeGradient = false
    AG_PanelGearPanel.useFadeGradient = false
    AG_PanelSkillPanel.useFadeGradient = false

    AG_UI_Button.data = { tip = AG.name }
    AG_PanelUndressArmor.data = { info = L.Unequip }
    AG_PanelUndressAll.data = { info = L.UnequipAll }
    AG_PanelSetPanelScrollChildEditPanelSetGearPanelGearLock.data = { info = L.Lock }
	
    local profileCombo = ZO_ComboBox_ObjectFromContainer(AG_PanelProfilePanel:GetNamedChild("ProfileSelect"))
	AG.SetupProfileCombo(profileCombo)
end


function AG.DrawBuild(nr)
    trace ("DrawBuild")

    local panelWidth = 427

    local p,l,s = WM:GetControlByName('AG_SetSelector_'..(nr-1)) or false
    local function Slide(sc,fc,sa)
        local ani = ANIMATION_MANAGER:CreateTimeline()
        local slide = ani:InsertAnimation(ANIMATION_SIZE,sc)
        local fade = ani:InsertAnimation(ANIMATION_ALPHA,fc,145)
        fc:SetHidden(not fc:IsHidden())
        fc:SetAlpha(0)
        fade:SetAlphaValues(0,1)
        fade:SetDuration(100)
        slide:SetStartAndEndHeight(76,431)
        slide:SetStartAndEndWidth(panelWidth,panelWidth)
        slide:SetDuration(150)
        if sa then ani:PlayFromStart() else ani:PlayFromEnd() end
    end

    s = WM:CreateControl('AG_SetSelector_'..nr, AG_PanelSetPanelScrollChild, CT_BUTTON)
    
    if p then s:SetAnchor(1,p,4,0,5) else s:SetAnchor(3,nil,3,0,0) end
    
    s:SetDimensions(panelWidth, 76)
    s:SetClickSound('Click')
    s:EnableMouseButton(2,true)
    s:SetNormalTexture('AlphaGear/grey.dds')
    s:SetMouseOverTexture('AlphaGear/light.dds')
    s.setnr = nr
    s:SetHandler('OnMouseEnter',function(self) AG.Tooltip(self,true) end)
    s:SetHandler('OnMouseExit',function(self) AG.Tooltip(self,false) end)
    s:SetHandler('OnMouseDown',
        function(self,button)
            if button == 2 then
                local k,anchor = AG_PanelSetPanelScrollChildEditPanel
                anchor = {k:GetAnchor()}
                if anchor[3] and anchor[3] ~= self then
                    anchor[3]:SetHeight(76)
                    k:SetHidden(true)
                    anchor[3]:GetNamedChild('Box'):SetHidden(false)
                    anchor[3]:GetNamedChild('Edit'):SetHidden(true)
                end
                k:ClearAnchors()
                k:SetAnchor(6,self,6,2,-2)
                Slide(self,k,k:IsHidden())
                WM:GetControlByName('AG_SetSelector_'..nr..'Box'):ToggleHidden()
                WM:GetControlByName('AG_SetSelector_'..nr..'Edit'):ToggleHidden()
                AG.UpdateEditPanel(self.setnr)
                AG_PanelIcons:SetHidden(true)
                SELECT = nr
            elseif button == 1 then 
                AG.LoadSet(nr) 
            end
        end
    )

    -- creates label for set number
    l = WM:CreateControl('AG_SetSelector_'..nr..'Label', s, CT_LABEL)
    l:SetAnchor(3,s,3,0,0)
    l:SetDrawTier(1)
    l:SetDimensions(44,44)
    l:SetHorizontalAlignment(1)
    l:SetVerticalAlignment(1)
    l:SetFont('AGFontBold')
    l:SetColor(1,1,1,0.8)
    l:SetText(nr)

    -- creates label for key binding
    l = WM:CreateControl('AG_SetSelector_'..nr..'KeyBind', s, CT_LABEL)
    l:SetAnchor(9,s,9,-15,0)
    l:SetDrawTier(1)
    l:SetDimensions(235,44)
    l:SetHorizontalAlignment(2)
    l:SetVerticalAlignment(1)
    l:SetFont('AGFont')
    l:SetColor(1,1,1,0.5)

    -- creates label for set name if in diplay mode
    l = WM:CreateControl('AG_SetSelector_'..nr..'Box', s, CT_LABEL)
    l:SetAnchor(3,s,3,2,44)
    l:SetDrawTier(1)
    l:SetDimensions(panelWidth-6, 30)
    l:SetHorizontalAlignment(0)
    l:SetVerticalAlignment(1)
    l:SetFont('AGFont')
    l:SetColor(1,1,1,1)

    -- text edit for set name in edit mode
    p = WM:CreateControlFromVirtual('AG_SetSelector_'..nr..'Edit', s, 'ZO_DefaultEditForBackdrop')
    p:ClearAnchors()
    p:SetAnchor(128,l,128,0,4)
    p:SetDimensions(panelWidth-22, 30)
    p:SetFont('AGFont')
    p:SetColor(1,1,1,1)
    p:SetMaxInputChars(100)
    p:SetHidden(true)
    p:SetHandler('OnFocusLost',function(self)
        AG.setdata[nr].Set.text[1] = self:GetText()
        self:LoseFocus()
        AG.UpdateUI(nr,nr)
    end)
    p:SetHandler('OnEscape',function(self) self:LoseFocus() end)
    p:SetHandler('OnEnter',function(self) self:LoseFocus() end)
    
    -- dark background for set-name
    p = WM:CreateControl('AG_SetSelector_'..nr..'BoxBg', s, CT_BACKDROP)
    p:SetDrawTier(1)
    p:SetAnchor(128,l,128,0,0)
    p:SetDimensions(panelWidth-8, 30)
    p:SetCenterColor(0,0,0,0.2)
    p:SetEdgeColor(0,0,0,0)
    p:SetEdgeTexture('',1,1,2)
end

--- Draws the set selection panel
-- Number of visible buttons is determined by "setamount"
function AG.DrawSetButtonsUI()
    trace ("DrawSetButtonsUI")

    local xpos,ypos,c = 0,0
    for x = 1, MAXSLOT do
        c = WM:GetControlByName('AG_UI_SetButton_'..x)
        if not c then
            c = WM:CreateControl('AG_UI_SetButton_'..x, AG_SetButtonFrame, CT_BUTTON)
            c:SetDimensions(24,24)
            c:SetHorizontalAlignment(1)
            c:SetVerticalAlignment(1)
            c:SetClickSound('Click')
            c:SetFont('AGFontSmall')
            c:SetNormalFontColor(1,1,1,1)
            c:SetMouseOverFontColor(1,0.66,0.2,1)
            c:SetText(x)
            c:SetNormalTexture('AlphaGear/grey.dds')
            c:SetMouseOverTexture('AlphaGear/light.dds')
            c:SetHandler('OnMouseEnter',function(self) AG.TooltipSet(x,true) end)
            c:SetHandler('OnMouseExit',function(self) AG.TooltipSet(x,false) end)
            c:SetHandler('OnClicked',function(self) AG.LoadSet(x) end)
        end
        c:ClearAnchors()
        c:SetAnchor(3,AG_SetButtonFrame,3,xpos,ypos)
        if x > AG.setdata.setamount then c:SetHidden(true) else c:SetHidden(false) end
        if x == math.ceil(AG.setdata.setamount/2) then ypos = ypos + 29; xpos = 0
        else xpos = xpos + 29 end
    end
end




function AG.GetButton(c)
    local res, name = {}, {string.match(c:GetName(),'AG_(%a+)_(%a+)_(%d+)_(%d+)')}
    table.insert(res, name[2])
    table.insert(res, tonumber(name[3]))
    table.insert(res, tonumber(name[4]))
    return unpack(res)
end

function AG.GetSoulgem()
    trace ('GetSoulGem started')
	
	local result, tier = false, 0
    local bag = SHARED_INVENTORY:GenerateFullSlotData(nil,BAG_BACKPACK)
    
	for _,data in pairs(bag) do
        if IsItemSoulGem(SOUL_GEM_TYPE_FILLED,BAG_BACKPACK,data.slotIndex) then
            local geminfo = GetSoulGemItemInfo(BAG_BACKPACK,data.slotIndex)
            if geminfo > tier then
				tier = geminfo;
				result = data.slotIndex 
			end
        end
    end
    
	return result
end


function AG.GetSetIcon(nr,bar)
    trace ('GetSetIcon started')

    local endicon,gear,icon = nil, AG.setdata[nr].Gear, {
        [WEAPONTYPE_NONE] = 'nothing',
        [WEAPONTYPE_DAGGER] = 'onehand',
        [WEAPONTYPE_HAMMER] = 'onehand',
        [WEAPONTYPE_AXE] = 'onehand',
        [WEAPONTYPE_SWORD] = 'onehand',
        [WEAPONTYPE_TWO_HANDED_HAMMER] = 'twohand',
        [WEAPONTYPE_TWO_HANDED_AXE] = 'twohand',
        [WEAPONTYPE_TWO_HANDED_SWORD] = 'twohand',
        [WEAPONTYPE_FIRE_STAFF] = 'fire',
        [WEAPONTYPE_FROST_STAFF] = 'frost',
        [WEAPONTYPE_LIGHTNING_STAFF] = 'shock',
        [WEAPONTYPE_HEALING_STAFF] = 'heal',
        [WEAPONTYPE_BOW] = 'bow',
        [WEAPONTYPE_SHIELD] = 'shield'
    }
    if bar == 1 then
        if gear[2].link ~= 0 then endicon = icon[GetItemLinkWeaponType(gear[2].link)]
        else endicon = icon[GetItemLinkWeaponType(gear[1].link)] end
    else
        if gear[4].link ~= 0 then endicon = icon[GetItemLinkWeaponType(gear[4].link)]
        else endicon = icon[GetItemLinkWeaponType(gear[3].link)] end
    end
    if endicon then return 'AlphaGear/'..endicon..'.dds' else return nil end
end

function AG.GetSkillFromBar(nr)
    trace('GetSkillFromBar')
    for x = 1,6 do

        local abilityId = GetSlotBoundId(x+2)
        local baseAbilityId = 0

        if abilityId ~= 0 then
            baseAbilityId = AG.GetBaseAbilityId(abilityId)
        end

        AG.setdata[nr].Skill[x] = baseAbilityId

        AG.ShowButton(WM:GetControlByName('AG_Button_Skill_'..nr..'_'..x))
    end
end


function AG.OnDragReceive(c)
    local function Contains(tab,item) 
        for _, value in pairs(tab) do 
            if value == item then 
                return true 
            end 
        end 
        return false 
    end
    
    local function CheckItems(nr,target)
        local clear, et1, et2 = false, GetItemLinkEquipType(AG.setdata[nr].Gear[1].link), GetItemLinkEquipType(AG.setdata[nr].Gear[3].link)
        
        if DRAGINFO.type == EQUIP_TYPE_TWO_HAND then
            if target == 1 then 
                clear = 2 
            elseif target == 3 then 
                clear = 4 
            end
        elseif DRAGINFO.type == EQUIP_TYPE_ONE_HAND or DRAGINFO.type == EQUIP_TYPE_OFF_HAND then
            if target == 2 and et1 == EQUIP_TYPE_TWO_HAND then 
                clear = 1 
            elseif target == 4 and et2 == EQUIP_TYPE_TWO_HAND then 
                clear = 3 
            end
        end

        if clear then
            AG.setdata[nr].Gear[clear] = { id = 0, link = 0 }
            AG.ShowButton(WM:GetControlByName('AG_Button_Gear_'..nr..'_'..clear))
        end
        
        for _,slot in pairs(DUPSLOTS) do
            if AG.setdata[nr].Gear[slot].id == DRAGINFO.uid then
                AG.setdata[nr].Gear[slot] = { id = 0, link = 0 }
                AG.ShowButton(WM:GetControlByName('AG_Button_Gear_'..nr..'_'..slot))
                return
            end
        end
    end

    local function CheckSkills(nr)
        for x = 1,5 do
            if AG.setdata[nr].Skill[x] == DRAGINFO.id then
                AG.setdata[nr].Skill[x] = 0
                AG.ShowButton(WM:GetControlByName('AG_Button_Skill_'..nr..'_'..x))
                return
            end
        end
    end

    local function DropItem(btn)
        local _, nr, slot = AG.GetButton(btn)
        if DRAGINFO.uid and Contains(DRAGINFO.slot,slot) then
            if Contains(DUPSLOTS,slot) then 
                CheckItems(nr,slot) 
            end
            
            AG.setdata[nr].Gear[slot] = { id = DRAGINFO.uid, link = DRAGINFO.link }
            AG.ShowButton(btn)
            ClearCursor()
            PlaySound('Tablet_PageTurn')
        end
    end

    local function DropSkill(btn)
        local _, nr, slot = AG.GetButton(btn)
        if DRAGINFO.id then
            if (not DRAGINFO.ultimate and slot < 6) or (DRAGINFO.ultimate and slot == 6) then
                if slot < 6 then CheckSkills(nr) end
                AG.setdata[nr].Skill[slot] = DRAGINFO.id
                AG.ShowButton(btn)
                ClearCursor()
                PlaySound('Tablet_PageTurn')
            end
        end
    end
    
    local cursor = GetCursorContentType()
    if cursor == MOUSE_CONTENT_INVENTORY_ITEM or cursor == MOUSE_CONTENT_EQUIPPED_ITEM then 
        DropItem(c)
    elseif cursor == MOUSE_CONTENT_ACTION then 
        DropSkill(c) 
    end
end


function AG.ClearAvailableEquipmentCache()
    trace ('ClearAvailableEquipmentCache')
    AVAIL_EQUIPMENT_CACHE = nil
    if not AG_Panel:IsHidden() then 
        table.insert (AG.Jobs, {AG.JOB_TYPE_UPDATE_UI, 0, 0})
    end
end

--- defines a filter for items in bags which are searched
local function GetItemDataFilterComparator()
    return function(itemData)
        if itemData.itemType == ITEMTYPE_ARMOR or itemData.itemType == ITEMTYPE_WEAPON or itemData.itemType == ITEMTYPE_POISON then
            -- precalculate the IDString for later use
            itemData.IdStringAG = Id64ToString(itemData.uniqueId)
            return true
        end
    end
end

--- builds a cache of items which are armor or weapons out of items in BAG_WORN or BAG_BACKPACK
function AG.GetAvailableEquipmentCache()
    if not AVAIL_EQUIPMENT_CACHE then

        local comparator = GetItemDataFilterComparator()

        if IMGR:IsBanking() then
            local bankingBag = GetBankingBag()

            if bankingBag == BAG_BANK then
                -- we're using a normal banker
                AVAIL_EQUIPMENT_CACHE = SHARED_INVENTORY:GenerateFullSlotData(comparator, BAG_BACKPACK, BAG_WORN, BAG_BANK, BAG_SUBSCRIBER_BANK)
            else 
                -- we're using a house bank
                AVAIL_EQUIPMENT_CACHE = SHARED_INVENTORY:GenerateFullSlotData(comparator, BAG_BACKPACK, BAG_WORN, bankingBag)
            end
        else
            AVAIL_EQUIPMENT_CACHE = SHARED_INVENTORY:GenerateFullSlotData(comparator, BAG_BACKPACK, BAG_WORN)
        end
    end

    return AVAIL_EQUIPMENT_CACHE
end

function AG.SwapItemInCache (oldSlot, newBag, newSlot)
    local aveq = AG.GetAvailableEquipmentCache()
   
    for _, itemData in pairs(aveq) do 
        if oldSlot == itemData.slotIndex and BAG_WORN == itemData.bagId then 
            trace("Moved: "..itemData.name.." from Bag/Slot: "..itemData.bagId.."/"..itemData.slotIndex.." to Bag/Slot: "..newBag.."/"..newSlot)
            itemData.slotIndex = newSlot
            itemData.bagId = newBag
            return
        end 
    end
end


function AG.GetItemFromBag(id)
    if not id then return false end

    local aveq = AG.GetAvailableEquipmentCache()
    
    for _, itemData in pairs(aveq) do 
        if id == itemData.IdStringAG then 
            trace("Found in cache: "..itemData.name.." Bag/Slot: "..itemData.bagId.."/"..itemData.slotIndex)
            return itemData.bagId, itemData.slotIndex 
        end 
    end
    
    return false
end

--- Loads an item of a gear-set
-- @param nr Number of gear-set
-- @param slotIndex Number of slot 
function AG.LoadItem(nr, slotIndex, set)
    if not nr or not slotIndex then return end

    local targetSlot = SLOTS[slotIndex][1]

    if AG.setdata[nr].Gear[slotIndex].id ~= 0 then

        table.insert(AG.Jobs, {AG.JOB_TYPE_EQUIP_GEAR, AG.setdata[nr].Gear[slotIndex], targetSlot}) 

--[[
        if Id64ToString(GetItemUniqueId(BAG_WORN, targetSlot)) ~= AG.setdata[nr].Gear[slotIndex].id then
            local sourceBag, sourceBagSlot = AG.GetItemFromBag(AG.setdata[nr].Gear[slotIndex].id)

            if sourceBagSlot then 
                -- CallSecureProtected("RequestMoveItem", bag, sourceBagSlot, BAG_WORN, targetSlot, 1)
                -- d("Equip. Source-Bag: "..sourceBag.." -Slot: "..sourceBagSlot.." Target-Slot: ".. targetSlot)

                table.insert(AG.Jobs, {AG.JOB_TYPE_EQUIP_GEAR, sourceBag, sourceBagSlot, targetSlot}) 

--[ [                
                -- equip the found item
                EquipItem(sourceBag, sourceBagSlot, targetSlot)

                -- the equipped item has changed place with the item, that was in the targetSlot. Update cache accordingly
                AG.SwapItemInCache (targetSlot, sourceBag, sourceBagSlot)
--] ]
            else
                d(ZOSF(L.NotFound,AG.setdata[nr].Gear[slotIndex].link)) 
            end
        end
--]]
    elseif set and AG.setdata[set].Set.lock == 1 then
        -- this will corrupt the cache, if the unequipped item is used in a later slot. Not a real use-case...
        table.insert(AG.Jobs, {AG.JOB_TYPE_UNEQUIP_GEAR, targetSlot}) 
    end
end

--- loads a gear-set
-- @param nr Number of gear-set
-- @param set Number of set
function AG.LoadGear(nr, set)
    if not nr then return end
    AG.ClearAvailableEquipmentCache()

    for slotIndex = 1, #SLOTS do
        AG.LoadItem(nr, slotIndex, set) 
    end
end

-- find skillType, skillLine and abilityIndex by abilityId
function AG.GetSkill(abilityId)
    local hasProgression, progressionIndex = GetAbilityProgressionXPInfoFromAbilityId(abilityId)

    if not hasProgression then
        trace('Ability with ID %d has no progression.', abilityId)
        return false
    end
  
    local skillType, skillLine, abilityIndex = GetSkillAbilityIndicesFromProgressionIndex(progressionIndex)
    if skillType > 0 then 
        return skillType, skillLine, abilityIndex 
    end
  

    for skillType = 1, GetNumSkillTypes() do
        for skillLine = 1, GetNumSkillLines(skillType) do
            for abilityIndex = 1, GetNumSkillAbilities(skillType, skillLine) do
                
                local progId = select(7, GetSkillAbilityInfo(skillType, skillLine, abilityIndex))
                
                if progId == progressionIndex then 
                    trace ('Found Skill Type %d, Line %d, Index %d', skillType, skillLine, abilityIndex)
                    return skillType, skillLine, abilityIndex 
                end
                        
                -- Returns: number abilityId
                -- if GetSkillAbilityId(skillType, skillLine, abilityIndex, false) == abilityId then 
                   --  trace ('Found Skill Type %d, Line %d, Index %d', skillType, skillLine, abilityIndex)
                    -- return skillType, skillLine, abilityIndex 
                -- end
            end
        end
    end
    return false
end


function AG.GetBaseAbilityId(abilityId)
    -- Returns: boolean hasProgression, number progressionIndex, number lastRankXp, number nextRankXP, number currentXP, boolean atMorph
    local hasProgression, progressionIndex = GetAbilityProgressionXPInfoFromAbilityId(abilityId)

    trace ('Progression Index: %s,  %d', tostring(hasProgression), progressionIndex)
    
    if not hasProgression then
        trace('Ability with ID %d has no progression.', abilityId)
        return 0 
    end


    local name, morph, rank = GetAbilityProgressionInfo(progressionIndex)
    trace('PI %d, Name %s, Morph %d, rank %d.', progressionIndex, name, morph, rank)
    
    local baseAbilityId = GetAbilityProgressionAbilityId(progressionIndex, morph, rank)
    trace('BaseAbilityId: %d.',  baseAbilityId)

    return baseAbilityId
end


--- returns the abilityIndex for a given abilityId
function AG.GetAbility(abilityId)
    trace ('Searching Ability with ID %d', abilityId)


    -- local exists = DoesAbilityExist(abilityId)
    -- trace ('Ability exists: %s', tostring(exists))
    
    -- local  texName = GetAbilityIcon(abilityId)
    -- trace ('Ability texture: %s', texName)
    
    -- local st, si, ai, mc, ri = GetSpecificSkillAbilityKeysByAbilityId(abilityId)
    -- trace ('Specific keys: %d, %d, %d, %d', si, ai, mc, ri)
    
    -- Returns: boolean hasProgression, number progressionIndex, number lastRankXp, number nextRankXP, number currentXP, boolean atMorph
    local hasProgression, progressionIndex = GetAbilityProgressionXPInfoFromAbilityId(abilityId)

    trace ('Progression Index: %s,  %d', tostring(hasProgression), progressionIndex)
    
    if not hasProgression then
        trace('Ability with ID %d has no progression.', abilityId)
        return 0 
    end


    -- Returns: string name, number morph, number rank
    local _, morph, rank = GetAbilityProgressionInfo(progressionIndex)

    -- Returns: string name, string texture, number abilityIndex
    local name, _, abilityIndex = GetAbilityProgressionAbilityInfo(progressionIndex, morph, rank)
    if abilityIndex then 
        trace('Found ability %s with Index %d for ID %d.', name, abilityIndex, abilityId)
        return abilityIndex 
    else 
        trace('Did not find ability with ID %d.', abilityId)
        return 0 
    end
end


function AG.LoadSkill(nr, slot)
    if not nr or not slot then return end

    local skillID = AG.setdata[nr].Skill[slot]
    
    -- TODO remove skill from bar, if set is locked and skillID == 0
    if skillID == 0 then return end

    local currentSkillID = GetSlotBoundId(slot+2)

    if skillID ~= currentSkillID then
        trace('SkillId in slot %d changed. Current: %d new: %d', slot, currentSkillID, skillID)
        local newAbilityIndex = AG.GetAbility(skillID)
        local currentAbilityIndex = AG.GetAbility(currentSkillID)

        if newAbilityIndex ~= 0 and currentAbilityIndex ~= newAbilityIndex then 
            trace('AbilityIndex has changed, replacing. Current AI: %d, New AI: %d', currentAbilityIndex, newAbilityIndex)
            CallSecureProtected('SelectSlotAbility', newAbilityIndex, slot+2) 
        end
    end
end

function AG.LoadBar(nr)
    if not nr then return end
    for slot = 1, 6 do AG.LoadSkill(nr,slot) end
end



function AG.ShowOutfits()
    local n = OFMGR:GetNumOutfits()

    for i = 1, n do
        local ofman = OFMGR:GetOutfitManipulator(i)
        local name = ofman:GetOutfitName()
        d("Available Outfit "..i..":"..name)
    end


    local ofid = OFMGR:GetEquippedOutfitIndex()

    if ofid == nil then
        d("Nothing equipped")
    else
        d("Equipped: "..ofid)
    end
end

function AG.SetupOutfitCombo(dropdown, setnr)

    local currentOutfitIndex = AG.setdata[setnr].Set.outfit


    dropdown:ClearItems()

    local function OnKeepOutfitSelected()
        AG.setdata[setnr].Set.outfit = AG.OUTFIT_KEEP
    end

    local function OnNoOutfitSelected()
        AG.setdata[setnr].Set.outfit = AG.OUTFIT_NONE
    end

    local function OnOutfitEntrySelected(_, _, entry)
        AG.setdata[setnr].Set.outfit = entry.outfitIndex
    end

    -- Add Keep-Outfit Item
    local keepOutfitEntry = ZO_ComboBox:CreateItemEntry(L.KeepOutfitItemLabel, OnKeepOutfitSelected)
    dropdown:AddItem(keepOutfitEntry, ZO_COMBOBOX_SUPRESS_UPDATE)

    -- Add No-Outfit Item
    local unequippedOutfitEntry = ZO_ComboBox:CreateItemEntry(GetString(SI_NO_OUTFIT_EQUIP_ENTRY), OnNoOutfitSelected)
    dropdown:AddItem(unequippedOutfitEntry, ZO_COMBOBOX_SUPRESS_UPDATE)

    local defaultEntry = unequippedOutfitEntry
    if currentOutfitIndex == AG.OUTFIT_KEEP  then
        defaultEntry = keepOutfitEntry
    end

    -- Add available Outfit Items
    local numOutfits = OFMGR:GetNumOutfits()
    for outfitIndex = 1, numOutfits do
        local outfitManipulator = OFMGR:GetOutfitManipulator(outfitIndex)
        local entry = ZO_ComboBox:CreateItemEntry(outfitManipulator:GetOutfitName(), OnOutfitEntrySelected)
        entry.outfitIndex = outfitIndex
        dropdown:AddItem(entry, ZO_COMBOBOX_SUPRESS_UPDATE)
        if currentOutfitIndex == outfitIndex then
            defaultEntry = entry
        end
    end

    dropdown:UpdateItems()
    dropdown:SelectItem(defaultEntry)
end


function AG.SetupProfileCombo(dropdown)

    dropdown:ClearItems()

    local function OnProfileSelected(_, _, entry)
		AG.loadProfile(entry.profileId)
    end

    local defaultEntry

    -- Add available Profiles
    for profileId = 1, MAX_PROFILES do
        local entry = ZO_ComboBox:CreateItemEntry(AG.setdata.profiles[profileId].name, OnProfileSelected)
        entry.profileId = profileId
        dropdown:AddItem(entry, ZO_COMBOBOX_SUPRESS_UPDATE)
        if AG.setdata.currentProfileId == profileId then
            defaultEntry = entry
        end
    end

    dropdown:UpdateItems()
    dropdown:SelectItem(defaultEntry)
end


function AG.LoadOutfit(outfitid)
    if not outfitid then return end

    if outfitid == AG.OUTFIT_NONE then
        UnequipOutfit()
    elseif outfitid == AG.OUTFIT_KEEP then
        -- Just do nothing
    else
        OFMGR:EquipOutfit(outfitid)
    end
end

function AG.ToggleSet()
    if AG.setdata.lastset and AG.previousSet then
        AG.LoadSet (AG.previousSet)
    else
        d(L.MsgNoPreviousSet)
    end
end

function AG.LoadNextSet()
    local nextSet

    if AG.setdata.lastset and AG.setdata.lastset < MAXSLOT then
        nextSet = AG.setdata.lastset + 1
    else
        nextSet = 1
    end

    AG.LoadSet (nextSet)
end

function AG.LoadPreviousSet()
    local nextSet

    if AG.setdata.lastset and AG.setdata.lastset > 1 then
        nextSet = AG.setdata.lastset - 1
    else
        nextSet = MAXSLOT
    end

    AG.LoadSet (nextSet)
end


--- equips gear, activates skills and deals with outfits as configured in a set
-- @param nr Number of set to load
function AG.LoadSet(nr)
    if not nr then return end

    if IsUnitInCombat("player") then 
        AG.pendingSet = nr
        d(ZOSF(L.SetChangeQueuedMsg, nr, AG.setdata[nr].Set.text[1]))
    else
        AG.LoadSetInternal(nr)
    end

end


--- does the work of equipping. No checks
function AG.LoadSetInternal(nr)
    trace("LoadSetInternal: %d", nr)

    if AreActionBarsLocked() then
        d("Action bars are locked. Can't load set. You might have to relaod the UI!")
        return
    end
	
	-- sheathe weapons
	if not ArePlayerWeaponsSheathed() then
        TogglePlayerWield()
		trace("Weapons sheathed")
    end

    if nr ~= AG.setdata.lastset then
        AG.previousSet = AG.setdata.lastset
    end
    AG.setdata.lastset = nr
    AG.pendingSet = -1

    local pair = GetActiveWeaponPairInfo()

    -- set outfit
    AG.LoadOutfit (AG.setdata[nr].Set.outfit)

    -- load gear
    if AG.setdata[nr].Set.gear ~= 0 then AG.LoadGear(AG.setdata[nr].Set.gear, nr) end

    -- load skills, wait until gear has loaded
    if AG.setdata[nr].Set.skill[pair] ~= 0 then
        table.insert(AG.Jobs, {AG.JOB_TYPE_LOAD_SKILL_BAR, AG.setdata[nr].Set.skill[pair], nil}) 
        --- AG.LoadBar(AG.setdata[nr].Set.skill[pair]) 
    end

    -- queue in swap message
    SWAP = true
    table.insert(AG.Jobs, {AG.JOB_TYPE_SHOW_SWAP_MSG, nil, nil}) 
end

function AG.Undress(mode)
    if mode == 1 then 
        for x = 5, 11 do 
            table.insert(AG.Jobs, {AG.JOB_TYPE_UNEQUIP_GEAR, SLOTS[x][1]}) 
        end
    else 
        for _,x in pairs(SLOTS) do 
            table.insert(AG.Jobs, {AG.JOB_TYPE_UNEQUIP_GEAR, x[1]}) 
        end 
    end
end

function AG.DoTransfer(sourceBagId, sourceBagSlot)
    ClearCursor()
    local result = CallSecureProtected("PickupInventoryItem", sourceBagId, sourceBagSlot, 1)
    if result then
        result = CallSecureProtected("PlaceInTransfer")
    end
    ClearCursor()
end

function AG.WithdrawItem(sourceBagId, sourceBagSlot)
    
    if DoesBagHaveSpaceFor(BAG_BACKPACK, sourceBagId, sourceBagSlot) then
        AG.DoTransfer(sourceBagId, sourceBagSlot)
    else
        local link = GetItemLink(sourceBagId, sourceBagSlot)
        d(ZOSF(L.NotEnoughSpaceInBackPack, link))         
    end
end


function AG.DepositItem(sourceBagId, sourceBagSlot)

    if IsItemStolen(sourceBagId, sourceBagSlot) then
        local link = GetItemLink(sourceBagId, sourceBagSlot)
        d(ZOSF(L.ItemIsStolen, link)) 
    else

        -- GetBankingBag() returns BAG_BANK for BAG_BANK and BAG_SUBSCRIBER_BANK, and BAG_HOUSE_BANK_nnn for house banking
        local bankingBag = GetBankingBag()
        local canAlsoBePlacedInSubscriberBank = bankingBag == BAG_BANK

        if DoesBagHaveSpaceFor(bankingBag, bag, index) or (canAlsoBePlacedInSubscriberBank and DoesBagHaveSpaceFor(BAG_SUBSCRIBER_BANK, bag, index)) then
            AG.DoTransfer(sourceBagId, sourceBagSlot)
        else
            local link = GetItemLink(sourceBagId, sourceBagSlot)
            d(ZOSF(L.NotEnoughSpaceInBank, link)) 
        end                
    end
end

function AG.UnequipItem(slot)
    if GetItemInstanceId(BAG_WORN, slot) then
        if GetNumBagFreeSlots(BAG_BACKPACK) > 0 then
            UnequipItem(slot)
        else
            local link = GetItemLink(BAG_WORN, slot)
            d(ZOSF(L.NotEnoughSpaceInBackPack, link))         
        end
    end
end

function AG.EquipItem(gear, targetSlot)

	-- return true, if we must wait
	local result = false
	
	-- anything to change?
    if Id64ToString(GetItemUniqueId(BAG_WORN, targetSlot)) ~= gear.id then

		-- find item in one of the bags
		local sourceBag, sourceBagSlot = AG.GetItemFromBag(gear.id)

		if sourceBagSlot then 
			-- equip the found item
			EquipItem(sourceBag, sourceBagSlot, targetSlot)

			-- the equipped item has changed place with the item, that was in the targetSlot. Update cache accordingly
			AG.SwapItemInCache (targetSlot, sourceBag, sourceBagSlot)
			
			result = true
		else
			d(ZOSF(L.NotFound, gear.link)) 
		end	
	end
	
	return result
end


--- moves a gear set to or from BAG_BACKPACK
-- @param deposit: if true then deposit the set to the current open bank, else withdraw
-- @param nr: number of set
function AG.MoveGearSet(deposit, nr)
    if not nr then return end
    AG.ClearAvailableEquipmentCache()

    for slotIndex = 1, #SLOTS do 
        local id = AG.setdata[nr].Gear[slotIndex].id
        if id and id ~= 0 then
            local sourceBag, sourceBagSlot = AG.GetItemFromBag(id)

            -- is item in cache?
            if sourceBagSlot ~= nil then

                if deposit then
                    -- only items in backpack can be deposited
                    if sourceBag == BAG_BACKPACK then
                        table.insert(AG.Jobs, {AG.JOB_TYPE_DEPOSIT_GEAR, sourceBag, sourceBagSlot}) 
                    elseif sourceBag == BAG_WORN then
                        local link = AG.setdata[nr].Gear[slotIndex].link
                        d(ZOSF(L.CurrentlyEquipped, link)) 
                    end
                else
                    -- only items not worn and not in backpack can be withdrawn
                    if sourceBag ~= BAG_BACKPACK and sourceBag ~= BAG_WORN then
                        table.insert(AG.Jobs, {AG.JOB_TYPE_WITHDRAW_GEAR, sourceBag, sourceBagSlot}) 
                    end
                end
            end
        end
    end
end

function AG.HandleOnUpdate()
    if AG.init and #AG.Jobs > 0 then
        local CurrentTime = GetGameTimeMilliseconds()

        if CurrentTime >= AG.NextEventTime or AG.NextEventTime == 0 then

            -- get next job
            local job =  AG.Jobs[1]
            local jobType, param1, param2, param3 = job[1], job[2], job[3], job[4]
			local mustWait = true

            if (jobType == AG.JOB_TYPE_UNEQUIP_GEAR) then
                AG.UnequipItem(param1)
            elseif (jobType == AG.JOB_TYPE_EQUIP_GEAR) then
                mustWait = AG.EquipItem(param1, param2)
            elseif (jobType == AG.JOB_TYPE_WITHDRAW_GEAR) then
                AG.WithdrawItem(param1, param2) 
            elseif (jobType == AG.JOB_TYPE_DEPOSIT_GEAR) then
                AG.DepositItem(param1, param2) 
            elseif (jobType == AG.JOB_TYPE_UPDATE_UI) then
                AG.UpdateUI() 
            elseif (jobType == AG.JOB_TYPE_LOAD_SKILL_BAR) then
                AG.LoadBar(param1) 
            elseif (jobType == AG.JOB_TYPE_SHOW_SWAP_MSG) then
                AG_SwapMessage:SetHidden(true)
                AG_SwapMessageBg:SetHidden(true)
                AG.SwapMessage()
            end

            table.remove(AG.Jobs, 1) 
            
			if mustWait then
				-- next event in 250ms from now
				AG.NextEventTime = CurrentTime + 100
			end
        end
    end
end


function AG.Animate(fadeIn,slideIn,fadeOut)
    trace('Animate')
    local a = ANIMATION_MANAGER:CreateTimeline()
    local c = AG_SwapMessage
    if fadeIn then
        local fi = a:InsertAnimation(ANIMATION_ALPHA,c)
        c:SetAlpha(0)
        c:SetHidden(false)
        -- c:SetAnchor(2,AG_SwapMessageBg,8,0,0)
        fi:SetAlphaValues(0,1)
        fi:SetDuration(400)
    end
    if fadeOut then
        local fo = a:InsertAnimation(ANIMATION_ALPHA,c,fadeOut)
        fo:SetAlphaValues(1,0)
        fo:SetDuration(150)
    end
    if slideIn then
        local si = a:InsertAnimation(ANIMATION_TRANSLATE,c)
        si:SetStartOffsetX(800)
        si:SetEndOffsetX(15)
        si:SetStartOffsetY(-22)
        si:SetEndOffsetY(-22)
        si:SetDuration(500)
        si:SetEasingFunction(ZO_GenerateCubicBezierEase(.25,.5,.4,1.2))
    end
    a:PlayFromStart()
end

function AG.UpdateRepair(_,bag)
    trace('UpdateRepair')

    if bag ~= BAG_WORN then return end
    local condition, count, allcost, con, minval = 0, 0, 0, 0, 100
    for _,c in pairs(SLOTS) do
        if DoesItemHaveDurability(BAG_WORN,c[1]) then
            con = GetItemCondition(BAG_WORN,c[1])
            if con <= minval then minval = con end
            condition = condition + con
            allcost = allcost + GetItemRepairCost(BAG_WORN,c[1])
            count = count + 1
        end
    end
	
	if count == 0 then
		minval = ''
		condition = 0
	else
		if minval < 100 then minval = ' ('..minval..'%)' else minval = '' end
		condition = math.floor(condition/count) or 0
	end
	
    AG_RepairTex:SetColor(GetColor(condition,1))
    AG_RepairValue:SetText(condition..'%'..minval)
    AG_RepairValue:SetColor(GetColor(condition,1))
    AG_RepairCost:SetText(allcost..' |t12:12:esoui/art/currency/currency_gold.dds|t')
end



function AG.showItemLevel(lblLevel, itemLink, silChoice)

    local requiredLevel = GetItemLinkRequiredLevel(itemLink)
    local requiredChampionPoints = GetItemLinkRequiredChampionPoints(itemLink)
	local dRelLevel

    local playerCP = GetPlayerChampionPointsEarned()

	-- current max for CP is 160
	if playerCP > 160 then playerCP = 160 end

	
    if requiredChampionPoints > 0 then
		-- the Item has CP, thus the player has at least as many CP
		dRelLevel = math.floor(requiredChampionPoints^2 / playerCP^2 * 100)
		
        -- local pointsString = failed and ZO_ERROR_COLOR:Colorize(requiredChampionPoints) or ZO_DEFAULT_ENABLED_COLOR:Colorize(requiredChampionPoints)
        -- self:AddSubLabel(zo_iconFormat(GetChampionPointsIcon(), "40", "40"))
        -- self:AddSubLabel(pointsString)
		-- strLabel = zo_iconFormat(GetChampionPointsIcon(), "10", "10")..requiredChampionPoints
    elseif requiredLevel > 0 then
		-- item doesn't have CP, but maybe the player

        local playerLevel = GetUnitLevel("player")
		local virtLevel = playerLevel + playerCP / 10

		dRelLevel = math.floor(requiredLevel^2 / virtLevel^2 * 100)
		
        -- local levelString = failed and ZO_ERROR_COLOR:Colorize(requiredLevel) or ZO_DEFAULT_ENABLED_COLOR:Colorize(requiredLevel)
        -- self:AddSubLabel(GetString(SI_ITEM_FORMAT_STR_LEVEL))
        -- self:AddSubLabel(levelString)
		-- strLabel = requiredLevel
    else
		-- item has level 0
		dRelLevel = 0.0
    end
	
	if dRelLevel == 100 and silChoice == AG.CHOICE_SHOW_ITEM_LEVEL_LOW then
		lblLevel:SetHidden(true)
	else
		if dRelLevel == 100 then
			lblLevel:SetTexture('AlphaGear/lvlcirc.dds')
		else
			lblLevel:SetTexture('AlphaGear/lvldown.dds')
		end
		-- self:AddSubLabel(GetItemLinkFlavorText(itemLink))
		-- lblLevel:SetText(strLabel)
		lblLevel:SetHidden(false)
		lblLevel:SetColor(GetColor(dRelLevel, 0.9))
	end

end


--- Updates the condition indicator controls.
-- Sets the color depending on the condition of the item
-- Only for items currently equipped.
function AG.UpdateCondition(_,bag,slot)
    if bag ~= BAG_WORN or slot == EQUIP_SLOT_COSTUME then
		return
	end
	
    local t = WM:GetControlByName('AG_InvBg'..slot)
	local l = WM:GetControlByName('AG_InvBg'..slot..'Condition')
	local lblLevel = WM:GetControlByName('AG_InvBg'..slot..'Level')
	
    local p, s = t:GetParent()

    p:SetMouseOverTexture(not ZO_Character_IsReadOnly() and 'AlphaGear/mo.dds' or nil)
    p:SetPressedMouseOverTexture(not ZO_Character_IsReadOnly() and 'AlphaGear/mo.dds' or nil)
    
	s = p:GetNamedChild('DropCallout')
    s:ClearAnchors()
    s:SetAnchor(1,p,1,0,2)
    s:SetDimensions(52,52)
    s:SetTexture('AlphaGear/spot.dds')
    s:SetDrawLayer(0)
	
    s = p:GetNamedChild('Highlight')
	if s then
        s:ClearAnchors()
        s:SetAnchor(1,p,1,0,2)
        s:SetDimensions(52,52)
        s:SetTexture('AlphaGear/spot.dds')
    end
	
    if GetItemInstanceId(BAG_WORN, slot) then
		local itemLink = GetItemLink(BAG_WORN,slot)
		
	    if AG.isShowItemQuality() then
            t:SetHidden(false)
            t:SetColor(Quality(itemLink, 1))
        else 
			t:SetHidden(true) 
		end
		
        if AG.isShowItemCondition() and DoesItemHaveDurability(BAG_WORN,slot) then
            local con = GetItemLinkCondition(itemLink)
            l:SetText(con..'%')
            l:SetColor(GetColor(con,0.9))
            l:SetHidden(false)
        else 
			l:SetHidden(true) 
		end
		
		local silChoice = AG.getShowItemLevel()
		if silChoice ~= AG.CHOICE_SHOW_ITEM_LEVEL_NEVER then
			AG.showItemLevel(lblLevel, itemLink, silChoice)
		else
			lblLevel:SetHidden(true)
		end
    else
        t:SetHidden(true)
        l:SetHidden(true)
		lblLevel:SetHidden(true)
    end
end


--- returns the label of the key bound to the control with name keyStr
function AG.GetKey(keyStr)
    -- trace('GetKey')
    local modifier = ''
    local l,c,a = GetActionIndicesFromName(keyStr)
    local key,m1,m2,m3,m4 = GetActionBindingInfo(l,c,a,1)
    if key ~= KEY_INVALID then
        local shift = ZO_Keybindings_DoesKeyMatchAnyModifiers(KEY_SHIFT,m1,m2,m3,m4)
        local ctrl = ZO_Keybindings_DoesKeyMatchAnyModifiers(KEY_CTRL,m1,m2,m3,m4)
        local alt = ZO_Keybindings_DoesKeyMatchAnyModifiers(KEY_ALT,m1,m2,m3,m4)
        if alt then modifier = modifier..string.format('%s-',string.upper(string.sub(GetString(SI_KEYCODEALT),1,8)))
        elseif ctrl then modifier = modifier..string.format('%s-',string.upper(string.sub(GetString(SI_KEYCODECTRL),1,8)))
        elseif shift then modifier = modifier..string.format('%s-',string.upper(string.sub(GetString(SI_KEYCODESHIFT),1,8))) end
        return modifier..GetKeyName(key)
    else return '' end
end


function AG.UpdateGearBorder(set)

    for slotIndex = 1, #SLOTS do 
        local b = WM:GetControlByName('AG_Button_Gear_'..set..'_'..slotIndex..'Bg')

        b:SetEdgeColor(AG.GetItemBorderColor(set, slotIndex))
    end
end


function AG.UpdateUI(from,to)
    trace('UpdateUI')
    if not from then from = 1 end
    if not to then to = MAXSLOT end
    local text = 'text'
    for x = from, to do
        if AG.setdata[x].Set.text[1] == 0 then text = 'Set '..x else text = AG.setdata[x].Set.text[1] end
        local header, c = '|cFFAA33'..text..'|r', ''
        WM:GetControlByName('AG_SetSelector_'..x).data = { header = header, info = L.Set }
        WM:GetControlByName('AG_SetSelector_'..x..'KeyBind'):SetText(AG.GetKey('AG_SET_'..x))
        c = WM:GetControlByName('AG_SetSelector_'..x..'Box')
        c:SetText('  '..text)
        AG.UpdateGearBorder(x)
    end
	
end

function AG.UpdateEditPanel(nr)
    if not nr then return end
    local val, set, c, _ = nil, AG.setdata[nr].Set

    -- Draws two rows of skill buttons in selected set
    for x = 1,2 do
        for slot = 1,6 do
            if set.skill[x] ~= 0 and AG.setdata[set.skill[x]].Skill[slot] ~= 0 then
                _, val = GetAbilityInfoByIndex(AG.GetAbility(AG.setdata[set.skill[x]].Skill[slot]))
            else 
                val = nil 
            end
            WM:GetControlByName('AG_Edit_Skill_'..x..'_'..slot):SetNormalTexture(val)
        end
    end

    -- Draws the gear buttons
    for slot = 1, #SLOTS do
        c = WM:GetControlByName('AG_Edit_Gear_1_'..slot)
        if set.gear > 0 and AG.setdata[set.gear].Gear[slot].id ~= 0 then
            c:SetNormalTexture(GetItemLinkInfo(AG.setdata[set.gear].Gear[slot].link))
            c:GetNamedChild('Bg'):SetCenterColor(Quality(AG.setdata[set.gear].Gear[slot].link,0.5))
        else
            c:SetNormalTexture('esoui/art/characterwindow/gearslot_'..SLOTS[slot][2]..'.dds')
            c:GetNamedChild('Bg'):SetCenterColor(0,0,0,0.2)
        end
    end

    -- draws skill bar 1
    if set.gear ~= 0 and AG.setdata[set.gear].Gear[1].id ~= 0 then val = Zero(set.icon[1]) or AG.GetSetIcon(set.gear,1)
    else val = Zero(set.icon[1]) or 'x.dds' end
    AG_PanelSetPanelScrollChildEditPanelSetBar1PanelBar1IconTex:SetTexture(val)
    

    -- draws skill bar 2
    if set.gear ~= 0 and AG.setdata[set.gear].Gear[3].id ~= 0 then val = Zero(set.icon[2]) or AG.GetSetIcon(set.gear,2)
    else val = Zero(set.icon[2]) or 'x.dds' end
    AG_PanelSetPanelScrollChildEditPanelSetBar2PanelBar2IconTex:SetTexture(val)

    -- builds set label for tooltip
    if AG.setdata[nr].Set.text[1] == 0 then val = '|cFFAA33Set '..nr..'|r' else val = '|cFFAA33'..AG.setdata[nr].Set.text[1]..'|r' end
    
    -- draws gear connector
    c = AG_PanelSetPanelScrollChildEditPanelSetGearPanelGearConnector
    c:SetText(Zero(set.gear) or '')
    c.data = { header = val, info = L.SetConnector[1] }

    -- draws bar 1 connector
    c = AG_PanelSetPanelScrollChildEditPanelSetBar1PanelBar1Connector
    c:SetText(Zero(set.skill[1]) or '')
    c.data = { header = val, info = L.SetConnector[2] }

    -- configure skill bar 1 icon tooltip
    c = AG_PanelSetPanelScrollChildEditPanelSetBar1PanelBar1Icon
    c.data = { header = val, info = L.ToolTipSkillIcon }

    -- draws bar 2 connector
    c = AG_PanelSetPanelScrollChildEditPanelSetBar2PanelBar2Connector
    c:SetText(Zero(set.skill[2]) or '')
    c.data = { header = val, info = L.SetConnector[3] }

    -- configure skill bar 2 icon tooltip
    c = AG_PanelSetPanelScrollChildEditPanelSetBar2PanelBar2Icon
    c.data = { header = val, info = L.ToolTipSkillIcon }
    
    
    -- draws set lock
    c = AG_PanelSetPanelScrollChildEditPanelSetGearPanelGearLockTex
    if set.lock == 0 then c:SetTexture('AlphaGear/unlocked.dds') else c:SetTexture('AlphaGear/locked.dds') end

    -- fills text edit for Bars
    AG_PanelSetPanelScrollChildEditPanelSetBar1PanelBar1NameEdit:SetText(Zero(set.text[2]) or L.ActionBar1Text)
    AG_PanelSetPanelScrollChildEditPanelSetBar2PanelBar2NameEdit:SetText(Zero(set.text[3]) or L.ActionBar2Text)
    
    -- fills text edit for Set Label
    WM:GetControlByName('AG_SetSelector_'..nr..'Edit'):SetText(Zero(set.text[1]) or 'Set '..nr)

    -- updates the outfitCombo
    c = ZO_ComboBox_ObjectFromContainer(AG_PanelSetPanelScrollChildEditPanelSetSettings:GetNamedChild("Dropdown"))
    AG.SetupOutfitCombo(c, nr)
end


function AG.UpdateInventory()
    local function SetItemMark(c)
        if not c then return end
        local function GetMark(c)
            local name = c:GetName()
            if not MARK[name] then MARK[name] = WM:CreateControl(name..'AG_ItemMark',c,CT_TEXTURE) end
            MARK[name]:SetDrawLayer(3)
            MARK[name]:SetDimensions(12,12)
            MARK[name]:SetHidden(true)
            MARK[name]:ClearAnchors()
            MARK[name]:SetAnchor(6,c:GetNamedChild('Bg'),6,2,0)
            MARK[name]:SetTexture('AlphaGear/mark.dds')
            return MARK[name]
        end
        local slot, mark, uid = c.dataEntry.data or nil, GetMark(c)
        uid = Id64ToString(GetItemUniqueId(slot.bagId,slot.slotIndex))
        if not slot or not uid then return end
        for nr = 1,MAXSLOT do
            if AG.setdata[nr].Set.gear > 0 then
                for slot = 1,14 do
                    if AG.setdata[AG.setdata[nr].Set.gear].Gear[slot].id == uid then
                        mark:SetHidden(false)
                        return
                    end
                end
            end
        end
    end
    local inv = {
        ZO_PlayerInventoryBackpack,ZO_PlayerBankBackpack,
        ZO_SmithingTopLevelDeconstructionPanelInventoryBackpack,
        ZO_SmithingTopLevelImprovementPanelInventoryBackpack,
    }
    for x = 1,#inv do
        local puffer = inv[x].dataTypes[1].setupCallback
        inv[x].dataTypes[1].setupCallback = function(c,slot)
            puffer(c,slot)
            if AG.isMarkSetItemsInBag() then SetItemMark(c) end
        end
    end
end


--- Tests, whether an item is available in BAG or WORN or not
-- @param nr Number of set
-- @slotIndex index of the slot
-- returns -2: No Item; -1: Item not found in available bags; > 0: BAG-ID
function AG.GetItemLocation(nr, slotIndex) 
    if not nr or not slotIndex then return -2 end

    local id = AG.setdata[nr].Gear[slotIndex].id
    if not id or id == 0 then return -2 end

    local sourceBag, sourceBagSlot = AG.GetItemFromBag(id)
    if sourceBagSlot == nil then
        return -1
    else
        return sourceBag
    end
end

function AG.GetItemBorderColor(nr, slotIndex)
    local loc = AG.GetItemLocation(nr, slotIndex)

    if loc == -1 then
        -- missing: red border
        return 1, 0, 0, 1
    elseif loc == -2 then
        -- No item: no border
        return 0, 0, 0, 0
    elseif loc == BAG_BANK or loc == BAG_SUBSCRIBER_BANK or IsHouseBankBag(loc) then
        -- in bank: yellow border
        return 1, 1, 0, 1
    elseif loc == BAG_WORN then
        -- currently worn: cyan border
        return 0, 1, 1, 1
    end

    -- in backpack: no border
    return 0, 0, 0, 0
end



--- Draws a green border at slots which might be a drag target
-- mode is one of 0 or 1. 0 disables the border
function AG.SetCallout(mode)
    for a = 1, MAXSLOT do
        for _,b in pairs(DRAGINFO.slot) do 
            -- defaults to no border
            local red, green, blue, alpha = 0, 0, 0, 0

            if mode == 1 then
                -- set green border
                green, alpha = 1, 1
            else 
                if DRAGINFO.panel == AG.MODE_GEAR then
                    red, green, blue, alpha = AG.GetItemBorderColor(a, b)
                end
            end

            -- set border color
            WM:GetControlByName('AG_Button_'..DRAGINFO.panel..'_'..a..'_'..b..'Bg'):SetEdgeColor(red, green, blue, alpha)
        end
    end
    
    if mode == 0 then
        DRAGINFO = {}
    end
end

function AG.SetConnect(parent,mode)
    local col, p = {'green','grey'}, {AG.MODE_SKILL, AG.MODE_SKILL, AG.MODE_GEAR}
    for nr = 1, MAXSLOT do
        WM:GetControlByName('AG_Selector_'..p[parent]..'_'..nr):SetNormalTexture('AlphaGear/'..col[mode]..'.dds')
    end
end

function AG.SetConnection(c,button)
    local name, mode = {string.match(c:GetName(),'(%a+)(%d)Connector')}
    mode = tonumber(name[2]) or 3
    SELECTBAR = mode
    if button == 1 then
        AG.SetConnect(mode,1)
    elseif button == 2 then
        if mode < 3 then AG.setdata[SELECT].Set.skill[SELECTBAR] = 0
        else AG.setdata[SELECT].Set.gear = 0 end
    end
    AG.UpdateEditPanel(SELECT)
end

function AG.SetSetLock()
    if SELECT then
        local set,c = AG.setdata[SELECT].Set
        c = AG_PanelSetPanelScrollChildEditPanelSetGearPanelGearLockTex
        if set.lock == 0 then
            set.lock = 1
            c:SetTexture('AlphaGear/locked.dds')
        else
            set.lock = 0
            c:SetTexture('AlphaGear/unlocked.dds')
        end
    end
end

function AG.SetSetName(mode,text)
    if not mode or not text then return end
    if SELECT then AG.setdata[SELECT].Set.text[mode] = text end
end




function AG.RepairItemInStore(bagId, slotId)
	local cost = GetItemRepairCost(bagId, slotId)
	if cost > GetCurrentMoney() then
        -- d("Not enough money to repair gear!")
        d(L.NotEnoughMoneyForRepairMsg)
		return -1
	else
		RepairItem(bagId, slotId)
		return cost
	end
end


function AG.RepairInStore()
	if not CanStoreRepair() then return end
	
	local totalCost = 0
	local repairedItems = 0
	local unrepairedItems = 0
	
	local bagId = BAG_WORN
	for slotId = 0, GetBagSize(bagId) do
		if DoesItemHaveDurability(bagId, slotId) then
			local itemName = GetItemName(bagId, slotId)
			if itemName ~= "" then
				local cost = AG.RepairItemInStore(bagId, slotId)
				if cost == -1 then 
					unrepairedItems = unrepairedItems + 1
				else
					repairedItems = repairedItems + 1
					totalCost = totalCost + cost
				end
			end
		end
	end

	if totalCost ~= 0 then
        --d(repairedItems.." Items repaired. Total repair cost: "..totalCost.."g")
        d(ZOSF(L.ItemsRepairedMsg, repairedItems, totalCost))
	end
	
	if unrepairedItems ~= 0 then
        -- d("Not enough gold for "..unrepairedItems.." Items")
        d(ZOSF(L.ItemsNotRepairedMsg, unrepairedItems))
	end
end


function AG.UpdateAndChargeItem (slot, agControl, texControl, valControl)
	trace('AG.UpdateAndChargeItem')
	
	if not IsItemChargeable(BAG_WORN, slot) then
		trace('Slot is not chargeable: %d', slot)
		Hide(agControl) 
		return
	end

	trace('Slot is chargeable: %d', slot)
		
    local chargeInfo = {GetChargeInfoForItem(BAG_WORN, slot)}
    local itemInfo = GetItemInfo(BAG_WORN, slot)
		
	if itemInfo then
	
		trace ('Slot is equipped; current charges: %d, max charges: %d', chargeInfo[1], chargeInfo[2])
		
		-- recharge if necessary
		-- test for charges < 5 to have some savety margin. 
        if chargeInfo[1] < 5 and AG.isAutoChargeWeapons() then
			trace('Slot is about to charge...')
            local gem = AG.GetSoulgem()
            if gem then
				trace('Slot: got soul gem, charging...')
			
                ChargeItemWithSoulGem(BAG_WORN, slot, BAG_BACKPACK, gem)
                d(ZOSF(L.SoulgemUsed, GetItemLink(BAG_WORN, slot)))

				if AG.isShowWeaponIcon() then
					-- get current chargeinfo for display
					chargeInfo = {GetChargeInfoForItem(BAG_WORN, slot)}
				end
			else
				trace('Slot: did not find a soul gem!')
            end
        end

		if AG.isShowWeaponIcon() then
			-- update control
			Show(agControl)
			local charge = math.ceil(chargeInfo[1]/chargeInfo[2]*100)
			texControl:SetTexture(itemInfo)
			valControl:SetText(charge.."%")
			valControl:SetColor(GetColor(charge,1))
			agControl:SetHidden(false)
		end
	else 
		trace ('Slot is not equipped')
		Hide(agControl) 
	end		
end


function AG.UpdatePoisonedWeapons(isBackPair)
	trace('AG.UpdatePoisonedWeapons called')

    -- hide icons for charged weapons
    Hide(AG_Charge2) 

    local weaponSlot = EQUIP_SLOT_MAIN_HAND
    local poisonSlot = EQUIP_SLOT_POISON

    if isBackPair then
        weaponSlot = EQUIP_SLOT_BACKUP_MAIN
        poisonSlot = EQUIP_SLOT_BACKUP_POISON
    end

    local hasPoison, poisonCount, poisonHeader, poisonItemLink = GetItemPairedPoisonInfo(weaponSlot)
    if hasPoison then
        trace('Weapons with poison equiped. Stack: %d', poisonCount)
    else 
        trace('Weapons without poison')
    end
    
    local itemInfo = GetItemInfo(BAG_WORN, poisonSlot)
		
	if itemInfo and AG.isShowWeaponIcon() then
        -- update control
        Show(AG_Charge1)
        AG_Charge1Tex:SetTexture(itemInfo)
        AG_Charge1Value:SetText(poisonCount)
        AG_Charge1Value:SetColor(GetColor(poisonCount,1))
        AG_Charge1:SetHidden(false)
    else 
        Hide(AG_Charge1) 
    end

end



function AG.UpdateChargedWeapons(isBackPair)
    trace('AG.UpdateChargedWeapons called')
    
    if isBackPair then
		trace('Back weapons equiped')
		AG.UpdateAndChargeItem (EQUIP_SLOT_BACKUP_MAIN, AG_Charge1, AG_Charge1Tex, AG_Charge1Value)
		AG.UpdateAndChargeItem (EQUIP_SLOT_BACKUP_OFF, AG_Charge2, AG_Charge2Tex, AG_Charge2Value)
    else
		trace('Front weapons equiped')
		AG.UpdateAndChargeItem (EQUIP_SLOT_MAIN_HAND, AG_Charge1, AG_Charge1Tex, AG_Charge1Value)
		AG.UpdateAndChargeItem (EQUIP_SLOT_OFF_HAND, AG_Charge2, AG_Charge2Tex, AG_Charge2Value)
	end
end



--- Handler for EVENT_INVENTORY_SINGLE_SLOT_UPDATE
function AG.UpdateWeaponStats(eventCode, bagId, slotId, isNewItem, itemSoundCategory, inventoryUpdateReason, stackSizeChange)
    trace('SingleSlotUpdate')
    
    -- safety net, shouldn't happen 
    if bagId ~= BAG_WORN then
		trace('Wrong bag for weapon stats. Exiting...')
		return 
	end

    -- ignore non-weapon/poison slots
    if slotId ~= EQUIP_SLOT_POISON and slotId ~= EQUIP_SLOT_BACKUP_POISON and slotId ~= EQUIP_SLOT_MAIN_HAND and 
        slotId ~= EQUIP_SLOT_OFF_HAND and slotId ~= EQUIP_SLOT_BACKUP_MAIN and slotId ~= EQUIP_SLOT_BACKUP_OFF then
        return
    end

    AG.ForceUpdateWeaponStats()
end

--- forces an update of the poison or charge icons
function AG.ForceUpdateWeaponStats()
    -- decide what to do
    local activeWeaponPair = GetActiveWeaponPairInfo()
    local isPoisonEquipped = false
    local isBackPair = false

    if (activeWeaponPair == ACTIVE_WEAPON_PAIR_MAIN) then
        isPoisonEquipped = HasItemInSlot(BAG_WORN, EQUIP_SLOT_POISON)
    elseif (activeWeaponPair == ACTIVE_WEAPON_PAIR_BACKUP) then
        isPoisonEquipped = HasItemInSlot(BAG_WORN, EQUIP_SLOT_BACKUP_POISON)
        isBackPair = true
    end

    if isPoisonEquipped then
        -- show poison stats
        trace('Poison is equiped')
        AG.UpdatePoisonedWeapons(isBackPair)
    else
        -- show weapon stats
        trace('Poison is not equipped')
        AG.UpdateChargedWeapons(isBackPair)
    end
end


-- Setup UI by settings
function AG.setupMainButton()
	local showMainButton = AG.isShowMainButton()
	
    AG_UI_Button:SetHidden(not showMainButton)
    AG_UI_ButtonBg:SetHidden(not showMainButton)
end


function AG.setupSetButtons()
	local showSetButtons = AG.isShowSetButtons()

    AG_SetButtonFrame:SetHidden(not showSetButtons)
    AG_SetButtonBg:SetHidden(not showSetButtons)
end

function AG.setupGearIcon()
	local showIcon = AG.isShowGearIcon()

    AG.layoutControl(AG_Repair, showIcon)
    AG_RepairValue:SetHidden(not showIcon)
    AG_RepairMainBg:SetHidden(not showIcon)
    AG_RepairCost:SetHidden(not AG.isShowRepairCost())

	if showIcon then
        EM:RegisterForEvent('AG_Event_Repair', EVENT_INVENTORY_SINGLE_SLOT_UPDATE, AG.UpdateRepair)
		-- only worn items need to be repaired
		EM:AddFilterForEvent('AG_Event_Repair', EVENT_INVENTORY_SINGLE_SLOT_UPDATE, REGISTER_FILTER_BAG_ID, BAG_WORN) 
        AG.UpdateRepair(nil, BAG_WORN)
    else
        EM:UnregisterForEvent('AG_Event_Repair', EVENT_INVENTORY_SINGLE_SLOT_UPDATE)
    end
end

function AG.setupWeaponIconsAndCharge()
	local showIcon = AG.isShowWeaponIcon()
	local autoChargeEnabled = AG.isAutoChargeWeapons()

    AG_Charge1:SetHidden(not showIcon)
    AG_Charge2:SetHidden(not showIcon)
	AG_ChargeMainBg:SetHidden(not showIcon)
	
	if autoChargeEnabled or showIcon then
	    EM:RegisterForEvent('AG_Event_Update_Weapon_Stats', EVENT_INVENTORY_SINGLE_SLOT_UPDATE, AG.UpdateWeaponStats)
		-- only worn items need to be recharged
		EM:AddFilterForEvent('AG_Event_Update_Weapon_Stats', EVENT_INVENTORY_SINGLE_SLOT_UPDATE, REGISTER_FILTER_BAG_ID, BAG_WORN) 
        AG.ForceUpdateWeaponStats()
	else
		EM:UnregisterForEvent('AG_Event_Update_Weapon_Stats', EVENT_INVENTORY_SINGLE_SLOT_UPDATE)
	end
end

function AG.setupMarkSetItems()
	local markItems = AG.isMarkSetItemsInBag()
end

function AG.setupItemCondition()
	local enabled = AG.isShowItemCondition()
	
    if enabled then
        EM:RegisterForEvent('AG_Event_Update_Condition', EVENT_INVENTORY_SINGLE_SLOT_UPDATE, AG.UpdateCondition)
    else
        EM:UnregisterForEvent('AG_Event_Update_Condition', EVENT_INVENTORY_SINGLE_SLOT_UPDATE)
    end

    for _,c in pairs(SLOTS) do AG.UpdateCondition(_, BAG_WORN, c[1]) end
end

function AG.setupItemQuality()
    for _,c in pairs(SLOTS) do AG.UpdateCondition(_, BAG_WORN, c[1]) end
end

function AG.setupAutoClose()
	local enabled = AG.isCloseWindowOnMove()
	
    if enabled then
		EM:RegisterForEvent('AG_Event_Movement', EVENT_NEW_MOVEMENT_IN_UI_MODE, function() SM:HideTopLevel(AG_Panel) end)
    else
		EM:UnregisterForEvent('AG_Event_Movement', EVENT_NEW_MOVEMENT_IN_UI_MODE) 
	end
end

function AG.setupLockUI()
	local locked = AG.isLockUI()

	for i = 1, table.getn(UIElements) do
		if UIElements[i]:GetName() ~= "AG_Panel" then
			UIElements[i]:SetMouseEnabled(not locked)
			UIElements[i]:SetMovable(not locked)
		end
	end

end


function AG.setupActiveSet()
    trace('setupActiveSet')

	local visible = AG.isShowActiveSet() and AG.setdata.lastset

    if visible then
        AG.UpdateSwapMessage()
    end

	AG_SwapMessage:SetHidden(not visible)
	AG_SwapMessageBg:SetHidden(not visible)
end

function AG.setupAutoRepairAtStores()
	local enabled = AG.isAutoRepairAtStores()
	
    if enabled then
		EM:RegisterForEvent('AG_Event_OpenStore', EVENT_OPEN_STORE, AG.RepairInStore)
    else
		EM:UnregisterForEvent('AG_Event_OpenStore', EVENT_OPEN_STORE) 
	end
end

function AG.setupShowItemLevel()
    for _,c in pairs(SLOTS) do AG.UpdateCondition(_, BAG_WORN, c[1]) end
end



function AG:SetOptions()
	AG.setupMainButton()
	AG.setupSetButtons()
	AG.setupGearIcon()
	AG.setupWeaponIconsAndCharge()
	AG.setupMarkSetItems()
	AG.setupItemCondition()
	AG.setupAutoClose()
	AG.setupLockUI()
	AG.setupActiveSet()
	AG.setupAutoRepairAtStores()
	
	AG.InitPositions()

	-- repaint of SetButtons
    AG.DrawSetButtonsUI()
end

--- Aligns Main Panel to the parent (skills or inventory), so that drag'n'drop is possible
function AG.AlignMainPanel(parent, pos)
    AG_Panel:ClearAnchors()
    AG_Panel:SetAnchor(RIGHT, parent, LEFT, pos, 0)
    AG_SwapMessage:SetHidden(true)
	AG_SwapMessageBg:SetHidden(true)
end

--- Resets the position of the main panel to it's previous state 
function AG.UnalignMainPanel()
    trace('UnalignMainPanel')
	local pos = AG.account.positions[AG_Panel:GetName()]

    AG_Panel:ClearAnchors()
    AG_Panel:SetAnchor(TOPLEFT, GuiRoot, TOPLEFT, pos[1], pos[2])

    local visible = AG.isShowActiveSet() and AG.setdata.lastset

    AG_SwapMessage:SetHidden(not visible)
	AG_SwapMessageBg:SetHidden(not visible)
end


function AG.InitPositions()
	for i = 1, table.getn(UIElements) do
		local name = UIElements[i]:GetName()
		local pos = AG.account.positions[name]
		
		if pos then
			UIElements[i]:ClearAnchors()
			UIElements[i]:SetAnchor(TOPLEFT, GuiRoot, TOPLEFT, pos[1], pos[2])
		end
	end
end


function AG.ResetPositions()
	for i = 1, table.getn(UIElements) do
		local name = UIElements[i]:GetName()

		UIElements[i]:ClearAnchors()
		
		if name == "AG_RepairMainBg" then
			-- special treatment for repair button
			UIElements[i]:SetAnchor(TOPLEFT, ActionButton8, TOPRIGHT, -5, -10)
		elseif name == "AG_ChargeMainBg" then
			-- special treatment for weapon button
			UIElements[i]:SetAnchor(TOPLEFT, ActionButton8, TOPRIGHT, 50, -10)
		else
			local pos = AG.account_defaults.positions[name]
			UIElements[i]:SetAnchor(TOPLEFT, GuiRoot, TOPLEFT, pos[1], pos[2])
		end
		
		AG.StorePosition(UIElements[i])
	end
end

function AG.StorePosition(control)
	local name = control:GetName()
	AG.account.positions[name] = {control:GetLeft(), control:GetTop()}
end

--- Opens a menu for manually choosing a skill bar icon
function AG.ShowIconMenu(c, button, bar)
    SELECTBAR = bar

    if button == 1 then
        -- show icon menu
        AG_PanelIcons:SetAnchor(6,c,12,0,0)
        AG_PanelIcons:ToggleHidden()
        if not AG_PanelIcons:IsHidden() then
            for x = 1,AG_PanelIconsScrollChild:GetNumChildren() do AG_PanelIconsScrollChild:GetChild(x):SetHidden(true) end
            local xpos,ypos,name,c = 10, 10
            for x,icon in pairs(ICON) do
                name = 'AG_SetIcon_'..x
                c = WM:GetControlByName(name)
                if not c then
                    c = WM:CreateControl(name,AG_PanelIconsScrollChild,CT_BUTTON)
                    c:SetAnchor(3,AG_PanelIconsScrollChild,3,xpos,ypos)
                    c:SetDimensions(64,64)
                    c:SetClickSound('Click')
                    c:SetMouseOverTexture('AlphaGear/light.dds')
                    c:SetHandler('OnClicked',function(self)
                        AG.setdata[SELECT].Set.icon[SELECTBAR] = icon
                        AG_PanelIcons:SetHidden(true)
                        AG.UpdateEditPanel(SELECT)
                    end)
                    if x%3 == 0 then xpos = 10; ypos = ypos + 69
                    else xpos = xpos + 69 end
                end
                c:SetNormalTexture(icon)
                c:SetHidden(false)
            end
            AG_PanelIconsScrollChild:SetHeight(math.ceil(#ICON/3)*69+10)
        end
    elseif button == 2 then 
        -- clear icon
        AG.setdata[SELECT].Set.icon[SELECTBAR] = 0
        AG.UpdateEditPanel(SELECT)
    end
end


--- Sets the texture of a skill or gear button
function AG.ShowButton(c)
    if not c then return false end
    local type, nr, slot = AG.GetButton(c)
    local skill, gear = AG.setdata[nr].Skill, AG.setdata[nr].Gear
    if type == AG.MODE_SKILL then
        if skill[slot] ~= 0 then
            local abilityIndex = AG.GetAbility(skill[slot])
            if abilityIndex ~= 0 then
                local _, icon = GetAbilityInfoByIndex(abilityIndex)
                c:SetNormalTexture(icon)
                c.data = { hint = L.Button[type] }
            end
        else
            c:SetNormalTexture()
            c.data = nil
        end
    else
        if gear[slot].link ~= 0 then
            c:SetNormalTexture(GetItemLinkInfo(gear[slot].link))
            c:GetNamedChild('Bg'):SetCenterColor(Quality(gear[slot].link,0.5))
            c.data = { hint = L.Button[type] }
        else
            c:SetNormalTexture('esoui/art/characterwindow/gearslot_'..SLOTS[slot][2]..'.dds')
            local b = c:GetNamedChild('Bg')
            b:SetCenterColor(0,0,0,0.2)
            b:SetEdgeColor(0, 0, 0, 0)
            c.data = nil
        end
    end
    if SELECT and not AG_PanelSetPanelScrollChildEditPanel:IsHidden() then
        if (nr == AG.setdata[SELECT].Set.gear or nr == AG.setdata[SELECT].Set.skill[1] or nr == AG.setdata[SELECT].Set.skill[2]) then 
            AG.UpdateEditPanel(SELECT) 
        end
    end
end


function AG.HandleCursorDropped()
    trace('HandleCursorDropped')

    if DRAGINFO.panel ~= nil then
        AG.SetCallout(0)
    end
end


function AG.HandleCursorPickup(eventCode, cursorType, param1, param2, param3, param4, param5, param6, itemSoundCategory)
    trace('HandleCursorPickup. CT: %d, P1: %d', cursorType, param1)

    if cursorType == MOUSE_CONTENT_INVENTORY_ITEM or cursorType == MOUSE_CONTENT_EQUIPPED_ITEM then
        local bag, slot
        
        if cursorType == MOUSE_CONTENT_INVENTORY_ITEM then
            bag=param1
            slot=param2
        else
            bag=BAG_WORN
            slot=param1
        end
        
        local itemType = GetItemType(bag, slot)

        if itemType == ITEMTYPE_ARMOR or itemType == ITEMTYPE_WEAPON or itemType == ITEMTYPE_POISON then
            local _,_,_,_,_,et = GetItemInfo(bag, slot)

            local gear = {
                [EQUIP_TYPE_HEAD] = { 5 },
                [EQUIP_TYPE_CHEST] = { 6 },
                [EQUIP_TYPE_LEGS] = { 7 },
                [EQUIP_TYPE_SHOULDERS] = { 8 },
                [EQUIP_TYPE_FEET] = { 9 },
                [EQUIP_TYPE_WAIST] = { 10 },
                [EQUIP_TYPE_HAND] = { 11 },
                [EQUIP_TYPE_NECK] = { 12 },
                [EQUIP_TYPE_RING] = { 13, 14 },
                [EQUIP_TYPE_MAIN_HAND] = { 1, 3 },
                [EQUIP_TYPE_ONE_HAND] = { 1, 2, 3, 4 },
                [EQUIP_TYPE_TWO_HAND] = { 1, 3 },
                [EQUIP_TYPE_OFF_HAND] = { 2, 4 },
                [EQUIP_TYPE_POISON] = { 15, 16 }
            }
            DRAGINFO.link = GetItemLink(bag, slot)
            DRAGINFO.uid = Id64ToString(GetItemUniqueId(bag, slot))
            DRAGINFO.type = et
            DRAGINFO.slot = gear[et]
            DRAGINFO.panel = AG.MODE_GEAR
            AG.SetCallout(1)
        end
    elseif cursorType == MOUSE_CONTENT_ACTION then
        local sourceSlot = param2
        local abilityIndex = param3
        local abilityId = GetAbilityIdByIndex(abilityIndex)
        local baseAbilityId = AG.GetBaseAbilityId(abilityId)

        trace ('Slot %d, AbilityIndex: %d, AbilityId: %d, BaseAbilityId: %d', sourceSlot, abilityIndex, abilityId, baseAbilityId)

        local baseSkillType, baseSkillindex, baseAbilityIndex, morphChoice = GetSpecificSkillAbilityKeysByAbilityId(baseAbilityId)
        trace ('BaseSkilltype %d, BaseSkillIndex: %d, BaseAbilityIndex: %d', baseSkillType, baseSkillindex, baseAbilityIndex)

        if baseSkillType and baseSkillindex and baseAbilityIndex then
            local _,_,_,_, ultimate, purchased = GetSkillAbilityInfo(baseSkillType, baseSkillindex, baseAbilityIndex)
            trace ('Ultimate %s, purchased: %s', tostring(ultimate), tostring(purchased))

            if purchased then
                DRAGINFO.id = baseAbilityId
                DRAGINFO.ultimate = ultimate
                DRAGINFO.panel = AG.MODE_SKILL
                if ultimate then 
                    DRAGINFO.slot = {6} 
                else
                    DRAGINFO.slot = {1,2,3,4,5}
                end

                AG.SetCallout(1)
            end
        end
    end
end

function AG.ShowMain()
    trace('ShowMain')
    SM:ToggleTopLevel(AG_Panel)
    if AG_Panel:IsHidden() then
        trace('Unregister DD-Events')
        EM:UnregisterForEvent('AG_Event_Cursor_Pickup', EVENT_CURSOR_PICKUP)
        EM:UnregisterForEvent('AG_Event_Cursor_Drop', EVENT_CURSOR_DROPPED)
    else
        AG.UpdateUI()
        trace('Register DD-Events')
        EM:RegisterForEvent('AG_Event_Cursor_Pickup', EVENT_CURSOR_PICKUP, AG.HandleCursorPickup)
        EM:RegisterForEvent('AG_Event_Cursor_Drop', EVENT_CURSOR_DROPPED, AG.HandleCursorDropped)
    end
end

function AG.HideMain()
    trace('HideMain')
    trace('Unregister DD-Events')
    SM:HideTopLevel(AG_Panel)
    EM:UnregisterForEvent('AG_Event_Cursor_Pickup', EVENT_CURSOR_PICKUP)
    EM:UnregisterForEvent('AG_Event_Cursor_Drop', EVENT_CURSOR_DROPPED)
end


function AG.UpdateSwapMessage()
    if AG.setdata.lastset then
        local pair = GetActiveWeaponPairInfo()
		local tex
		local barLabel
		local set = AG.setdata[AG.setdata.lastset].Set
		
		if pair == ACTIVE_WEAPON_PAIR_NONE then
			tex = 'AlphaGear/nothing.dds' 
			barLabel = 'None'
		else
			local pslot = {1,3}
        
			if set.gear ~= 0 and AG.setdata[set.gear].Gear[pslot[pair]].id ~= 0 then 
				tex = Zero(set.icon[pair]) or AG.GetSetIcon(set.gear,pair)
			else 
				tex = Zero(set.icon[pair]) or 'AlphaGear/nothing.dds' 
			end
			barLabel = Zero(set.text[pair + 1]) or ZOSF(L.ActionBarNText, pair)
		end
        
		local profileLabel = "Profile "..AG.setdata.currentProfileId
		
        AG_SwapMessageIcon:SetTexture(tex)
        AG_SwapMessageNumber:SetText(AG.setdata.lastset)
        AG_SwapMessageName:SetText(profileLabel..'\n'..(Zero(set.text[1]) or 'Set '..AG.setdata.lastset)..'\n|cFFFFFF'..barLabel)
    end
end

function AG.SwapMessage()
    trace('SwapMessage')

    AG.UpdateSwapMessage()

    if AG.isShowChangeNotification() and AG.setdata.lastset then
        PlaySound('Market_PurchaseSelected')
        if not AG.isShowActiveSet() then 
			AG.Animate(true,false,2500) 
		    AG_SwapMessageBg:SetHidden(true)
		else 
			AG.Animate(true,false,false) 
			AG_SwapMessageBg:SetHidden(false)
        end
    end
end

function AG.Swap(_,isSwap)
    if isSwap and not IsBlockActive() then
        if AG.setdata.lastset and SWAP then
            local pair = GetActiveWeaponPairInfo()
            if AG.setdata[AG.setdata.lastset].Set.skill[pair] ~= 0 then AG.LoadBar(AG.setdata[AG.setdata.lastset].Set.skill[pair]) end
            SWAP = false
        end
        if AG.isShowWeaponIcon() then AG.ForceUpdateWeaponStats() end
        AG.SwapMessage()
    end
end

function AG.MenuAction(nr)
    trace('MenuAction')

    if nr == 1 then
        -- Copy
        MENU.copy = MENU.nr
    elseif nr == 2 and MENU.copy then
        -- Paste
        if MENU.type == 1 then
            for z = 1, #SLOTS do
                AG.setdata[MENU.nr].Gear[z] = AG.setdata[MENU.copy].Gear[z]
                AG.ShowButton(WM:GetControlByName('AG_Button_Gear_'..MENU.nr..'_'..z))
            end	
        else 
            for z = 1,6 do
                AG.setdata[MENU.nr].Skill[z] = AG.setdata[MENU.copy].Skill[z]
                AG.ShowButton(WM:GetControlByName('AG_Button_Skill_'..MENU.nr..'_'..z))
            end 
        end
    elseif nr == 3 then
        -- Insert
        if MENU.type == 1 then 
            for x = 1, #SLOTS do
                if GetItemInstanceId(BAG_WORN, SLOTS[x][1]) then
                    AG.setdata[MENU.nr].Gear[x] = { id = Id64ToString(GetItemUniqueId(BAG_WORN,SLOTS[x][1])), link = GetItemLink(BAG_WORN,SLOTS[x][1]) }
                else 
                    AG.setdata[MENU.nr].Gear[x] = { id = 0, link = 0 } 
                end
                AG.ShowButton(WM:GetControlByName('AG_Button_Gear_'..MENU.nr..'_'..x))
            end 
        elseif MENU.type == 2 then 
            AG.GetSkillFromBar(MENU.nr) 
        end
    elseif nr == 4 then
        -- Clear
        if MENU.type == 1 then 
            for z = 1, #SLOTS do
                AG.setdata[MENU.nr].Gear[z] = { id = 0, link = 0 }
                AG.ShowButton(WM:GetControlByName('AG_Button_Gear_'..MENU.nr..'_'..z))
            end	
        elseif MENU.type == 2 then 
            for z = 1,6 do
                AG.setdata[MENU.nr].Skill[z] = 0
                AG.ShowButton(WM:GetControlByName('AG_Button_Skill_'..MENU.nr..'_'..z))
            end 
        else
            AG.setdata[MENU.nr].Set = { text = {0,0,0}, gear = 0, skill = {0,0}, icon = {0,0}, lock = 0 }
            AG.UpdateUI(MENU.nr,MENU.nr)
        end
    elseif nr == 5 then
        -- deposit
        if MENU.type == 1 then 
            AG.MoveGearSet(true, MENU.nr)
            AG.UpdateUI(MENU.nr,MENU.nr)
        end
    elseif nr == 6 then
        -- withdraw
        if MENU.type == 1 then 
            AG.MoveGearSet(false, MENU.nr)
            AG.UpdateUI(MENU.nr,MENU.nr)
        end
    end
end

function AG.Tooltip(c, visible, edit)
    -- trace('Tooltip')
    local function FadeIn(control)
        TTANI = ANIMATION_MANAGER:CreateTimeline()
        local fadeIn = TTANI:InsertAnimation(ANIMATION_ALPHA,control,400)
        fadeIn:SetAlphaValues(0,1)
        fadeIn:SetDuration(150)
        TTANI:PlayFromStart()
    end

    if not c then return end
    
    if visible then
        local type, nr, slot = AG.GetButton(c)

        if type == AG.MODE_GEAR then
            if edit then nr = AG.setdata[SELECT].Set.gear end
            if nr > 0 then
                if AG.setdata[nr].Gear[slot].link == 0 then return end

                c.text = ItemTooltip
                InitializeTooltip(c.text,AG_Panel,3,0,0,9)
                c.text:SetLink(AG.setdata[nr].Gear[slot].link)
                ZO_ItemTooltip_ClearCondition(c.text)
                ZO_ItemTooltip_ClearCharges(c.text)
            else return end
        elseif type == AG.MODE_SKILL then
            if edit then nr = AG.setdata[SELECT].Set.skill[nr] end
            if nr > 0 then

                if AG.setdata[nr].Skill[slot] == 0 then return end
                local s1,s2,s3 = AG.GetSkill(AG.setdata[nr].Skill[slot])
                if s1 and s2 and s3 then
                    c.text = SkillTooltip
                    InitializeTooltip(c.text,AG_Panel,3,0,0,9)
                    c.text:SetSkillAbility(s1,s2,s3)
                else
                    c.text = InformationTooltip
                    InitializeTooltip(c.text,AG_Panel,3,0,0,9)
                    c.text:AddLine(L.ReassignHint)
                end
            else return end
        elseif c.data and c.data.tip then
            c.text = InformationTooltip
            InitializeTooltip(c.text,c,2,5,0,8)
            SetTooltipText(c.text,c.data.tip)
            c.text:SetHidden(false)
            return
        else
            if c.data == nil then return end
            c.text = InformationTooltip
            InitializeTooltip(c.text,AG_Panel,3,0,0,9)
            if c.data.header then c.text:AddLine(c.data.header,'ZoFontWinH4') end
            SetTooltipText(c.text,c.data.info)
        end
        if c.data and c.data.hint then c.text:AddLine(c.data.hint,'ZoFontGame') end
        c.text:SetAlpha(0)
        c.text:SetHidden(false)
        FadeIn(c.text)
    else
        if c.text == nil then return end
        ClearTooltip(c.text)
        if TTANI then TTANI:Stop() end
        c.text:SetHidden(true)
        c.text = nil
    end
end

function AG.TooltipSet(nr,visible)
    if not nr then return end
    if visible then
        local set, val, _ = AG.setdata[nr].Set
        for z = 1,2 do
            local ico = ''
            for x = 1,6 do
                if set.skill[z] > 0 and AG.setdata[set.skill[z]].Skill[x] ~= 0 then
                    _, val = GetAbilityInfoByIndex(AG.GetAbility(AG.setdata[set.skill[z]].Skill[x]))
                else 
                    val = 'AlphaGear/grey1.dds' 
                end
                ico = ico..'|t36:36:'..val..'|t '
            end
            WM:GetControlByName('AG_SetTipBar'..z..'Skills'):SetText(ico)
            if set.gear ~= 0 then
                val = Zero(set.icon[z]) or AG.GetSetIcon(set.gear,z)
            else 
                val = 'AlphaGear/nothing.dds' 
            end
            WM:GetControlByName('AG_SetTipSkill'..z..'Icon'):SetTexture(val)
        end
        AG_SetTipName:SetText(Zero(set.text[1]) or 'Set '..nr)
        AG_SetTipBar1Name:SetText(Zero(set.text[2]) or 'Action-Bar 1')
        AG_SetTipBar2Name:SetText(Zero(set.text[3]) or 'Action-Bar 2')
        AG_SetTip:ClearAnchors()
        AG_SetTip:SetAnchor(6,AG_UI_SetButton_1,3,0,-2)
        AG_SetTip:SetHidden(false)
    else AG_SetTip:SetHidden(true) end
end


--- loads the set which was selected whil in combat
function AG.LoadPendingSet()
    if AG.pendingSet ~= -1 then
        AG.LoadSetInternal (AG.pendingSet)
    end
end


--- Handler for the PLayerCombatState, used to prevent in-combat-set-changes
function AG.OnPlayerCombatState(event, inCombat)
    if not inCombat then
        AG.LoadPendingSet()
    end
end


function KEYBINDING_MANAGER:IsChordingAlwaysEnabled()
	return true
end

function AlphaGear_RegisterIcon(icon)
	table.insert(ICON,icon or 'AlphaGear/nothing.dds')
end

function AG.CheckSkillId (nr, skillnr) 

    local oldSkillId = AG.setdata[nr].Skill[skillnr]
    if not DoesAbilityExist(oldSkillId) then
        trace ('Ability doesn\'t exist: %d', oldSkillId)
        local baseId = AGSkills17[oldSkillId]

        if baseId and baseId ~= 0 then
            if DoesAbilityExist(baseId) then
                trace ('Found Base Ability %s with ID %d',  GetAbilityName(baseId), baseId)
                AG.setdata[nr].Skill[skillnr] = baseId
            else 
                trace ('Invalid BaseId: %d', baseId)
            end
        else
            trace ('Old Ability not found')
        end
    else
        trace ('Found Old Ability: %s',  GetAbilityName(oldSkillId))
    end
end


--- initialise set list
function AG.initSetData(setdata)
    for x = 1, MAXSLOT do
        setdata[x] = {
            Gear = {}, 
            Skill = {},
            Set = { text = {0,0,0}, gear = 0, skill = {0,0}, icon = {0,0}, lock = 0, outfit = AG.OUTFIT_KEEP }
        }
        for z = 1, #SLOTS do setdata[x].Gear[z] = { id = 0, link = 0 } end
        for z = 1, 6 do setdata[x].Skill[z] = 0 end
    end 

end


--- stores the current set-list as profile with Id profileId
function AG.storeProfile(profileId)
	-- always clear
	AG.setdata.profiles[profileId].setdata = {}
    
	-- copy slots
	for i = 1, MAXSLOT do
		AG.setdata.profiles[profileId].setdata[i] = AG.setdata[i]		
	end
	
	-- copy current slotId
	AG.setdata.profiles[profileId].setdata.lastset = AG.setdata.lastset
end

--- loads profile with Id profileId as current set-list. 
-- stores the current set-list under its profileId
function AG.loadProfile(profileId)

	trace("AG.loadProfile %d", profileId)
	if profileId == AG.setdata.currentProfileId then 
		-- nothing to do
		return
	end
	
	-- store current set-list
	AG.storeProfile(AG.setdata.currentProfileId)
	
	-- lazy create new profile
	if not AG.setdata.profiles[profileId].setdata then
		AG.setdata.profiles[profileId].setdata = {}
		AG.setdata.profiles[profileId].setdata.lastset = false
		AG.initSetData(AG.setdata.profiles[profileId].setdata)
	end
	
	-- load new profile
    for i = 1, MAXSLOT do
		AG.setdata[i] = AG.setdata.profiles[profileId].setdata[i]
	end

	AG.setdata.lastset = AG.setdata.profiles[profileId].setdata.lastset
	
	AG.setdata.currentProfileId = profileId
	
	-- update UI and equip set
	-- skills & gear
	for setIndex = 1, MAXSLOT do
		for slotId = 1, 6 do
			AG.ShowButton(WM:GetControlByName('AG_Button_Skill_'..setIndex..'_'..slotId))
		end

		for slotId = 1, #SLOTS do
			AG.ShowButton(WM:GetControlByName('AG_Button_Gear_'..setIndex..'_'..slotId))
		end
	end
	
	
	AG.UpdateUI()
	AG.previousSet = nil
	AG.LoadSet(AG.setdata.lastset)
end


function AG:Initialize()

    SM:RegisterTopLevel(AG_Panel,false)
    EM:RegisterForEvent('AG4', EVENT_ACTION_SLOTS_FULL_UPDATE, AG.Swap)
    EM:RegisterForEvent('AG4', EVENT_INVENTORY_FULL_UPDATE, AG.ClearAvailableEquipmentCache)
    EM:RegisterForEvent('AG4', EVENT_PLAYER_COMBAT_STATE, AG.OnPlayerCombatState)
    EM:RegisterForEvent('AG4', EVENT_INVENTORY_ITEM_DESTROYED, AG.ClearAvailableEquipmentCache)
    EM:RegisterForEvent('AG4', EVENT_INVENTORY_SINGLE_SLOT_UPDATE, AG.ClearAvailableEquipmentCache)
    EM:RegisterForEvent('AG4', EVENT_OPEN_BANK, AG.ClearAvailableEquipmentCache)
    EM:RegisterForEvent('AG4', EVENT_CLOSE_BANK, AG.ClearAvailableEquipmentCache)
    
    -- EM:RegisterForEvent("AG4", EVENT_OUTFIT_EQUIP_RESPONSE, AG.ShowOutfits)
    -- EM:RegisterForEvent("AG4", EVENT_OUTFIT_CHANGE_RESPONSE, AG.ShowOutfits)


	UIElements = {AG_Panel, AG_UI_ButtonBg, AG_SetButtonBg, AG_SwapMessageBg, AG_RepairMainBg, AG_ChargeMainBg}
	
	SLASH_COMMANDS["/alphagear"]   = AG.ShowMain
	
	-- initialize account wide settings
    AG.account = ZO_SavedVars:NewAccountWide('AGX2_Account', AG.accountVariableVersion, nil, AG.account_defaults)
	
	
	-- initialize character wide settings
	
	local init_data =  AG.setdata_defaults
	AG.initSetData(init_data)
	
	--[[
    for x = 1, MAXSLOT do
        init_data[x] = {
            Gear = {}, 
            Skill = {},
            Set = { text = {0,0,0}, gear = 0, skill = {0,0}, icon = {0,0}, lock = 0, outfit = AG.OUTFIT_KEEP }
        }
        for z = 1, #SLOTS do init_data[x].Gear[z] = { id = 0, link = 0 } end
        for z = 1, 6 do init_data[x].Skill[z] = 0 end
    end 
	]]--
	
    AG.setdata = ZO_SavedVars:New('AGX2_Character', AG.characterVariableVersion, nil, init_data)
    
    -- Post-Load Check for missing members
    for x = 1, MAXSLOT do
        -- new since 6.2.0
        -- Outfit-ID
        if AG.setdata[x].Set.outfit == nil then
            AG.setdata[x].Set.outfit = AG.OUTFIT_KEEP
        end

        -- Slot for Poison
        if AG.setdata[x].Gear[15] == nil then
            AG.setdata[x].Gear[15] = { id = 0, link = 0 }
        end

        -- Slot for BackupPoison
        if AG.setdata[x].Gear[16] == nil then
            AG.setdata[x].Gear[16] = { id = 0, link = 0 }
        end
        -- end new since 6.2.0
        -- new since 6.3.0
        for z = 1, 6 do 
            AG.CheckSkillId (x, z)
        end
        -- end new since 6.3.0
    end
	
	-- Initialize profile structure
    if AG.setdata.profiles == nil then
		AG.setdata.currentProfileId = 1
		AG.setdata.profiles = {}
		
		for i = 1, MAX_PROFILES do
			AG.setdata.profiles[i] = {}
			AG.setdata.profiles[i].name = 'Profile '..i
			AG.setdata.profiles[i].currentBuild = 1
		end
		
		-- store main set-list as profile 1
		AG.storeProfile(1)
	end

	
	
	
	-- initialize settings page
	self:CreateSettingsPage()


    -- for x = 1, MAXSLOT do
    -- for z = 1,6 do
    -- if type(AG.setdata[x].Skill[z]) == 'table' then
    -- local a,b,c = unpack(AG.setdata[x].Skill[z])
    -- AG.setdata[x].Skill[z] = GetSkillAbilityId(a,b,c,false) or 0
    -- end
    -- end
    -- end

    AG.SetupMainPanel()

    AG.DrawSetButtonsUI()
    AG.DrawInventory()
    AG.UpdateInventory()
    
	AG:SetOptions()
    
	zo_callLater(AG.SwapMessage,900)
    -- AG_PanelOptionPanelPlus:SetAnchor(8,AG_Option_2,8,0,0)

    AlphaGear_RegisterIcon('AlphaGear/onehand.dds')
    AlphaGear_RegisterIcon('AlphaGear/onehand_aoe.dds')
    AlphaGear_RegisterIcon('AlphaGear/twohand.dds')
    AlphaGear_RegisterIcon('AlphaGear/twohand_aoe.dds')
    AlphaGear_RegisterIcon('AlphaGear/fire.dds')
    AlphaGear_RegisterIcon('AlphaGear/fire_aoe.dds')
    AlphaGear_RegisterIcon('AlphaGear/frost.dds')
    AlphaGear_RegisterIcon('AlphaGear/frost_aoe.dds')
    AlphaGear_RegisterIcon('AlphaGear/shock.dds')
    AlphaGear_RegisterIcon('AlphaGear/shock_aoe.dds')
    AlphaGear_RegisterIcon('AlphaGear/heal.dds')
    AlphaGear_RegisterIcon('AlphaGear/heal_aoe.dds')
    AlphaGear_RegisterIcon('AlphaGear/bow.dds')
    AlphaGear_RegisterIcon('AlphaGear/bow_aoe.dds')
    AlphaGear_RegisterIcon('AlphaGear/shield.dds')
    AlphaGear_RegisterIcon('AlphaGear/power.dds')
    AlphaGear_RegisterIcon('AlphaGear/bonehead.dds')
    AlphaGear_RegisterIcon('AlphaGear/training.dds')
    AlphaGear_RegisterIcon('AlphaGear/wolf.dds')
    AlphaGear_RegisterIcon('AlphaGear/vampire.dds')
    AlphaGear_RegisterIcon('AlphaGear/horse.dds')

    SELECT = AG.setdata.lastset

    AG.init = true
end

function AG.OnAddOnLoaded(event, addonName)
  if addonName ~= AG.name then return end

  EM:UnregisterForEvent('AG4',EVENT_ADD_ON_LOADED)
  
  AG:Initialize()
end


EM:RegisterForEvent('AG4', EVENT_ADD_ON_LOADED, AG.OnAddOnLoaded)

